module Ruconomic
  module API
    module AccountingPeriod
      extend Ruconomic::WebService

      # Returns an AccountingPeriod data object for a given accounting period.
      # Parameters: accountingPeriodHandle: A handle for the accounting period.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingPeriod_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('AccountingPeriod_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns AccountingPeriod data objects for a given set of accounting period handles.
      # Parameters: accountingPeriodHandles: An array of the accounting period handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingPeriod_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('AccountingPeriod_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all accounting periods.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingPeriod_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('AccountingPeriod_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Return handles for all accounting periods from date. fromDate is based on CET. includeCalculatedProperties is reserved for future usage and should be set to false for now.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingPeriod_GetAllUpdated
      # @return [Hash] The body content of the SOAP response.
      def self.get_all_updated
        response = invoke('AccountingPeriod_GetAllUpdated') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the period of an accounting period.
      # Parameters: accountingPeriodHandle: Handle for the accounting period.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingPeriod_GetPeriod
      # @return [Hash] The body content of the SOAP response.
      def self.get_period
        response = invoke('AccountingPeriod_GetPeriod') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the accounting year of an accounting period.
      # Parameters: accountingPeriodHandle: Handle for the accountingPeriod.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingPeriod_GetAccountingYear
      # @return [Hash] The body content of the SOAP response.
      def self.get_accounting_year
        response = invoke('AccountingPeriod_GetAccountingYear') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the from-date of the accounting period.
      # Parameters: accountingPeriodHandle: Handle for the accounting period.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingPeriod_GetFromDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_from_date
        response = invoke('AccountingPeriod_GetFromDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the to-date of the accounting period.
      # Parameters: accountingPeriodHandle: Handle for the accounting period.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingPeriod_GetToDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_to_date
        response = invoke('AccountingPeriod_GetToDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the status of the accounting period.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingPeriod_GetStatus
      # @return [Hash] The body content of the SOAP response.
      def self.get_status
        response = invoke('AccountingPeriod_GetStatus') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
