module Ruconomic
  module API
    module AccountingYear
      extend Ruconomic::WebService

      # Creates a new AccountingYear from a data object.
      # Parameters: data: The data object that specifies the properties of the new AccountingYear.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingYear_CreateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data
        response = invoke('AccountingYear_CreateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates new AccountingYear from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new AccountingYear.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingYear_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('AccountingYear_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an AccountingYear data object for a given accounting year.
      # Parameters: accountingYearHandle: A handle for the accounting year.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingYear_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('AccountingYear_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns AccountingYear data objects for a given set of accounting year handles.
      # Parameters: accountingYearHandles: An array of the accounting year handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingYear_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('AccountingYear_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the year of an accounting year.
      # Parameters: accountingYearHandle: Handle for the accounting year.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingYear_GetYear
      # @return [Hash] The body content of the SOAP response.
      def self.get_year
        response = invoke('AccountingYear_GetYear') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the from-date of the accounting year.
      # Parameters: accountingYearHandle: Handle for the accounting year.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingYear_GetFromDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_from_date
        response = invoke('AccountingYear_GetFromDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the to-date of the accounting year.
      # Parameters: accountingYearHandle: Handle for the accounting year.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingYear_GetToDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_to_date
        response = invoke('AccountingYear_GetToDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the isClosed boolean of the accounting year.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingYear_GetIsClosed
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_closed
        response = invoke('AccountingYear_GetIsClosed') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new accounting year.
      # Parameters: fromDate: The from date of the new accounting year. toDate: The to date of the new accounting year.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingYear_Create
      # @return [Hash] The body content of the SOAP response.
      def self.create
        response = invoke('AccountingYear_Create') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Deletes an accounting year.
      # Parameters: accountingYearHandle: Handle for the accounting year.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingYear_Delete
      # @return [Hash] The body content of the SOAP response.
      def self.delete
        response = invoke('AccountingYear_Delete') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all accounting years.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingYear_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('AccountingYear_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an array of handles for the accounting years within the given time interval.
      # Parameters: fromDate: First day in interval. toDate: Last day in interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingYear_FindByDate
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_date
        response = invoke('AccountingYear_FindByDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all accounting periods.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=AccountingYear_GetPeriods
      # @return [Hash] The body content of the SOAP response.
      def self.get_periods
        response = invoke('AccountingYear_GetPeriods') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
