module Ruconomic
  module API
    module CashBookEntry
      extend Ruconomic::WebService

      # Gets a handle for the distribution key of a cash book entry. The distribution key is only accessible when there is access to the Dimension add-on module.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetDistributionKey
      # @return [Hash] The body content of the SOAP response.
      def self.get_distribution_key
        response = invoke('CashBookEntry_GetDistributionKey') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the distribution key of a cash book entry. The distribution key is only accessible when there is access to the Dimension add-on module. The distribution key cannot be set when the department is set.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. value: Handle for the new distribution key of the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetDistributionKey
      # @return [Hash] The body content of the SOAP response.
      def self.set_distribution_key
        response = invoke('CashBookEntry_SetDistributionKey') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the project of a cash book entry. To set project use CashBookEntry_SetProjectAndCostType. The project is only accessible when there is access to the Project Management add-on module.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetProject
      # @return [Hash] The body content of the SOAP response.
      def self.get_project
        response = invoke('CashBookEntry_GetProject') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the cost type of a cash book entry. The cost type is only accessible when there is access to the Project Management add-on module. To set cost type use CashBookEntry_SetProjectAndCostType.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetCostType
      # @return [Hash] The body content of the SOAP response.
      def self.get_cost_type
        response = invoke('CashBookEntry_GetCostType') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the bank payment type of a cash book entry. To set bank payment type use CashBookEntry_SetRemittanceInformation.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetBankPaymentType
      # @return [Hash] The body content of the SOAP response.
      def self.get_bank_payment_type
        response = invoke('CashBookEntry_GetBankPaymentType') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the bank payment creditor id of a cash book entry. To set bank payment creditor id use CashBookEntry_SetRemittanceInformation.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetBankPaymentCreditorId
      # @return [Hash] The body content of the SOAP response.
      def self.get_bank_payment_creditor_id
        response = invoke('CashBookEntry_GetBankPaymentCreditorId') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the bank payment creditor invoice id of a cash book entry. To set bank payment creditor invoice id use CashBookEntry_SetRemittanceInformation.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetBankPaymentCreditorInvoiceId
      # @return [Hash] The body content of the SOAP response.
      def self.get_bank_payment_creditor_invoice_id
        response = invoke('CashBookEntry_GetBankPaymentCreditorInvoiceId') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the capitalise account of a cash book entry. To set the capitalise account use CashBookEntry_SetAccrualInformation. The capitalise account is only accessible when there is access to the Accruals add-on module.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetCapitalise
      # @return [Hash] The body content of the SOAP response.
      def self.get_capitalise
        response = invoke('CashBookEntry_GetCapitalise') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the start date of the accrual in a cash book entry. To set the start date use CashBookEntry_SetAccrualInformation. The start date is only accessible when there is access to the Accruals add-on module.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetStartDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_start_date
        response = invoke('CashBookEntry_GetStartDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the end date of the accrual in a cash book entry. To set the end date use CashBookEntry_SetAccrualInformation. The end date is only accessible when there is access to the Accruals add-on module.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetEndDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_end_date
        response = invoke('CashBookEntry_GetEndDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the employeeNo of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. value: new employeeNo.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetEmployee
      # @return [Hash] The body content of the SOAP response.
      def self.set_employee
        response = invoke('CashBookEntry_SetEmployee') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the employeeNo of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetEmployee
      # @return [Hash] The body content of the SOAP response.
      def self.get_employee
        response = invoke('CashBookEntry_GetEmployee') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new cash book entry.
      # Parameters: type: The type of the cash book entry. cashBook: The cash book of the cash book entry. debtor: The debtor of the cash book entry. creditor: The creditor of the cash book entry. account: The account of the cash book entry. contraAccount: The contra account of the cash book entry. 
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_Create
      # @return [Hash] The body content of the SOAP response.
      def self.create
        response = invoke('CashBookEntry_Create') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new cash book entry of type DebtorPayment.
      # Parameters: cashBook: The cash book of the cash book entry. debtor: The debtor of the cash book entry. account: The account of the cash book entry. contraAccount: The contra account of the cash book entry. 
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_CreateDebtorPayment
      # @return [Hash] The body content of the SOAP response.
      def self.create_debtor_payment
        response = invoke('CashBookEntry_CreateDebtorPayment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new cash book entry of type Manual customer invoice.
      # Parameters: cashBook: The cash book of the cash book entry. debtor: The debtor of the cash book entry. account: The account of the cash book entry. contraAccount: The contra account of the cash book entry. 
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_CreateManualDebtorInvoice
      # @return [Hash] The body content of the SOAP response.
      def self.create_manual_debtor_invoice
        response = invoke('CashBookEntry_CreateManualDebtorInvoice') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new cash book entry of type CreditorPayment.
      # Parameters: type: cashBook: The cash book of the cash book entry. creditor: The creditor of the cash book entry. contraAccount: The contra account of the cash book entry. 
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_CreateCreditorPayment
      # @return [Hash] The body content of the SOAP response.
      def self.create_creditor_payment
        response = invoke('CashBookEntry_CreateCreditorPayment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new cash book entry of type CreditorInvoice.
      # Parameters: cashBook: The cash book of the cash book entry. creditor: The creditor of the cash book entry. contraAccount: The contra account of the cash book entry. 
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_CreateCreditorInvoice
      # @return [Hash] The body content of the SOAP response.
      def self.create_creditor_invoice
        response = invoke('CashBookEntry_CreateCreditorInvoice') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new cash book entry of type FinanceVoucher.
      # Parameters: cashBook: The cash book of the cash book entry. account: The account of the cash book entry. contraAccount: The contra account of the cash book entry. 
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_CreateFinanceVoucher
      # @return [Hash] The body content of the SOAP response.
      def self.create_finance_voucher
        response = invoke('CashBookEntry_CreateFinanceVoucher') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Deletes a cash book entry.
      # Parameters: accountHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_Delete
      # @return [Hash] The body content of the SOAP response.
      def self.delete
        response = invoke('CashBookEntry_Delete') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new cash book entry from a data object.
      # Parameters: data: The data object that specifies the properties of the new cash book entry.
      #
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_CreateFromData
      # @return [Array] with cashbook entry ids.
      def self.create_from_data(entry_data)
        response = invoke('CashBookEntry_CreateFromData') do |message|
          message.add 'data' do |data|
            if handle_ids = entry_data.dig(:handle)
              data.add 'Handle' do |handle|
                handle.add 'Id1', handle_ids.dig(:id1)
                handle.add 'Id2', handle_ids.dig(:id2)
              end
            end
            data.add_optional('Id1', entry_data.dig(:id1))
            data.add_optional('Id2', entry_data.dig(:id2))
            data.add_optional('Type', entry_data.dig(:type))
            data.add_handle('CashBookHandle', entry_data.dig(:cash_book_handle, :number))
            data.add_handle('DebtorHandle', entry_data.dig(:debtor_handle, :number))
            data.add_handle('CreditorHandle', entry_data.dig(:creditor_handle, :number))
            data.add_handle('AccountHandle', entry_data.dig(:account_handle, :number))
            data.add_handle('ContraAccountHandle', entry_data.dig(:contra_account_handle, :number))
            data.add('Date', entry_data.dig(:date))
            data.add('VoucherNumber', entry_data.dig(:voucher_number))
            data.add('Text', entry_data.dig(:text))
            data.add('AmountDefaultCurrency', entry_data.dig(:amount_default_currency))
            data.add_handle('CurrencyHandle', entry_data.dig(:currency_handle, :code), 'Code')
            data.add('Amount', entry_data.dig(:amount))
            data.add_handle('VatAccountHandle', entry_data.dig(:vat_account_handle, :vat_code), 'VatCode')
            data.add_handle('ContraVatAccountHandle', entry_data.dig(:contra_vat_account_handle, :vat_code), 'VatCode')
            data.add_optional('DebtorInvoiceNumber', entry_data.dig(:debtor_invoice_number))
            data.add_optional('CreditorInvoiceNumber', entry_data.dig(:creditor_invoice_number))
            data.add('DueDate', entry_data.dig(:due_date))
            data.add_handle('ContraVatAccountHandle', entry_data.dig(:contra_vat_account_handle, :vat_code), 'VatCode')
            data.add_handle('DepartmentHandle', entry_data.dig(:department_handle, :number))
            data.add_handle('DistributionKeyHandle', entry_data.dig(:distribution_key_handle, :number))
            data.add_handle('ProjectHandle', entry_data.dig(:project_handle, :number))
            data.add_handle('CostTypeHandle', entry_data.dig(:cost_type_handle, :number))
            data.add_handle('BankPaymentTypeHandle', entry_data.dig(:bank_payment_type_handle, :number))
            data.add_optional('BankPaymentCreditorId', entry_data.dig(:bank_payment_creditor_id))
            data.add_optional('BankPaymentCreditorInvoiceId', entry_data.dig(:bank_payment_creditor_invoice_id))
            data.add_handle('CapitaliseHandle', entry_data.dig(:capitalise_handle, :number))
            data.add('StartDate', entry_data.dig(:start_date))
            data.add('EndDate', entry_data.dig(:end_date))
            data.add_handle('EmployeeHandle', entry_data.dig(:employee_handle, :number))
          end
        end

        response.to_hash.dig(
          :cash_book_entry_create_from_data_response,
          :cash_book_entry_create_from_data_result
        ).values
      end

      # Creates new cash book entries from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new cash book entries.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('CashBookEntry_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Update cash book entries from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('CashBookEntry_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates a cash book entry from a data object.
      # Parameters: data: The data object.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data
        response = invoke('CashBookEntry_UpdateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a cash book entry data object for a given cash book entry.
      # Parameters: entityHandle: A handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('CashBookEntry_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns cash book entry data objects for a given set of cash book entry handles.
      # Parameters: entityHandles: An array of the cash book entry handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('CashBookEntry_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the type of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetType
      # @return [Hash] The body content of the SOAP response.
      def self.get_type
        response = invoke('CashBookEntry_GetType') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the cash book of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetCashBook
      # @return [Hash] The body content of the SOAP response.
      def self.get_cash_book
        response = invoke('CashBookEntry_GetCashBook') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor of the cash book entry. The debtor is only accessible when the cash book entry is of type DebtorPayment.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor
        response = invoke('CashBookEntry_SetDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor of a cash book entry. The debtor is only accessible when the cash book entry is of type DebtorPayment.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor
        response = invoke('CashBookEntry_GetDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the creditor of a cash book entry. The creditor is only accessible when the cash book entry is of type CreditorInvoice or CreditorPayment.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetCreditor
      # @return [Hash] The body content of the SOAP response.
      def self.get_creditor
        response = invoke('CashBookEntry_GetCreditor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the creditor of a cash book entry. The creditor is only accessible when the cash book entry is of type CreditorInvoice or CreditorPayment.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetCreditor
      # @return [Hash] The body content of the SOAP response.
      def self.set_creditor
        response = invoke('CashBookEntry_SetCreditor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the account of a cash book entry. The account is only accessible when the cash book entry is of type FinanceVoucher.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetAccount
      # @return [Hash] The body content of the SOAP response.
      def self.set_account
        response = invoke('CashBookEntry_SetAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the account of a cash book entry. The account is only accessible when the cash book entry is of type FinanceVoucher.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetAccount
      # @return [Hash] The body content of the SOAP response.
      def self.get_account
        response = invoke('CashBookEntry_GetAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the contra account of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetContraAccount
      # @return [Hash] The body content of the SOAP response.
      def self.get_contra_account
        response = invoke('CashBookEntry_GetContraAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the contra account of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. valueHandle: handle for the new contra couunt.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetContraAccount
      # @return [Hash] The body content of the SOAP response.
      def self.set_contra_account
        response = invoke('CashBookEntry_SetContraAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the date of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. value: new date value.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetDate
      # @return [Hash] The body content of the SOAP response.
      def self.set_date
        response = invoke('CashBookEntry_SetDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the date of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_date
        response = invoke('CashBookEntry_GetDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the voucher number of a cash book entry. The voucher number must be at least 1.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. value: new voucher number.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetVoucherNumber
      # @return [Hash] The body content of the SOAP response.
      def self.set_voucher_number
        response = invoke('CashBookEntry_SetVoucherNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the voucher number of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetVoucherNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_voucher_number
        response = invoke('CashBookEntry_GetVoucherNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the text of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetText
      # @return [Hash] The body content of the SOAP response.
      def self.get_text
        response = invoke('CashBookEntry_GetText') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the text of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. value: new text value.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetText
      # @return [Hash] The body content of the SOAP response.
      def self.set_text
        response = invoke('CashBookEntry_SetText') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the amount (in default currency) of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetAmountDefaultCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_amount_default_currency
        response = invoke('CashBookEntry_GetAmountDefaultCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the amount (in default currency) of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. value: new amount value.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetAmountDefaultCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.set_amount_default_currency
        response = invoke('CashBookEntry_SetAmountDefaultCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the currency of the cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_currency
        response = invoke('CashBookEntry_GetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the currency of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. valueHandle: Handle for the new currency of the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.set_currency
        response = invoke('CashBookEntry_SetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the amount of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. value: new amount of the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetAmount
      # @return [Hash] The body content of the SOAP response.
      def self.set_amount
        response = invoke('CashBookEntry_SetAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the amount of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_amount
        response = invoke('CashBookEntry_GetAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the VAT account of a cash book entry. VAT account is only accessible when cash book entry is of type FinanceVoucher.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. valueHandle: new VAT account of the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetVatAccount
      # @return [Hash] The body content of the SOAP response.
      def self.set_vat_account
        response = invoke('CashBookEntry_SetVatAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the VAT account of a cash book entry. VAT account is only accessible when cash book entry is of type FinanceVoucher.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetVatAccount
      # @return [Hash] The body content of the SOAP response.
      def self.get_vat_account
        response = invoke('CashBookEntry_GetVatAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the contra VAT account of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetContraVatAccount
      # @return [Hash] The body content of the SOAP response.
      def self.get_contra_vat_account
        response = invoke('CashBookEntry_GetContraVatAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the contra VAT account of a cash book entry.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. valueHandle: new contra VAT account of the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetContraVatAccount
      # @return [Hash] The body content of the SOAP response.
      def self.set_contra_vat_account
        response = invoke('CashBookEntry_SetContraVatAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor invoice number of a cash book entry. Debtor invoice number is only accessible when cash book entry is of type DebtorPayment.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. value: new debtor invoice number.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetDebtorInvoiceNumber
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_invoice_number
        response = invoke('CashBookEntry_SetDebtorInvoiceNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor invoice number of a cash book entry. Debtor invoice number is only accessible when cash book entry is of type DebtorPayment.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetDebtorInvoiceNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_invoice_number
        response = invoke('CashBookEntry_GetDebtorInvoiceNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the creditor invoice number of a cash book entry. Creditor invoice number is only accessible when cash book entry is of type CreditorInvoice or CreditorPayment.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetCreditorInvoiceNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_creditor_invoice_number
        response = invoke('CashBookEntry_GetCreditorInvoiceNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the creditor invoice number of a cash book entry. Creditor invoice number is only accessible when cash book entry is of type CreditorInvoice or CreditorPayment.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. value: new debtor invoice number.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetCreditorInvoiceNumber
      # @return [Hash] The body content of the SOAP response.
      def self.set_creditor_invoice_number
        response = invoke('CashBookEntry_SetCreditorInvoiceNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the due date of a cash book entry. Due date is only accessible when cash book entry is of type CreditorInvoice.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. value: new due date.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetDueDate
      # @return [Hash] The body content of the SOAP response.
      def self.set_due_date
        response = invoke('CashBookEntry_SetDueDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the due date of a cash book entry. Due date is only accessible when cash book entry is of type CreditorInvoice.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetDueDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_due_date
        response = invoke('CashBookEntry_GetDueDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the department of a cash book entry. The department is only accessible when there is access to the Dimension add-on module. The department cannot be set when the distribution key is set.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry. value: Handle for the new department of the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_SetDepartment
      # @return [Hash] The body content of the SOAP response.
      def self.set_department
        response = invoke('CashBookEntry_SetDepartment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the department of a cash book entry. The department is only accessible when there is access to the Dimension add-on module.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CashBookEntry_GetDepartment
      # @return [Hash] The body content of the SOAP response.
      def self.get_department
        response = invoke('CashBookEntry_GetDepartment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
