module Ruconomic
  module API
    module Creditor
      extend Ruconomic::WebService

      # Gets the number of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_number
        response = invoke('Creditor_GetNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the creditor group of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetCreditorGroup
      # @return [Hash] The body content of the SOAP response.
      def self.get_creditor_group
        response = invoke('Creditor_GetCreditorGroup') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the creditor group of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. valueHandle: Handle for the new creditor group of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetCreditorGroup
      # @return [Hash] The body content of the SOAP response.
      def self.set_creditor_group
        response = invoke('Creditor_SetCreditorGroup') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the name of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetName
      # @return [Hash] The body content of the SOAP response.
      def self.get_name
        response = invoke('Creditor_GetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the name of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. value: The new name of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetName
      # @return [Hash] The body content of the SOAP response.
      def self.set_name
        response = invoke('Creditor_SetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets vat zone of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. value: Handle for new vat zone of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetVatZone
      # @return [Hash] The body content of the SOAP response.
      def self.set_vat_zone
        response = invoke('Creditor_SetVatZone') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handle for vat zone of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetVatZone
      # @return [Hash] The body content of the SOAP response.
      def self.get_vat_zone
        response = invoke('Creditor_GetVatZone') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets currency of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. value: Handle for the new currency of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.set_currency
        response = invoke('Creditor_SetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets currency of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_currency
        response = invoke('Creditor_GetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the term of payment of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetTermOfPayment
      # @return [Hash] The body content of the SOAP response.
      def self.get_term_of_payment
        response = invoke('Creditor_GetTermOfPayment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the term of payment of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. value: Handle for the new term of payment of a creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetTermOfPayment
      # @return [Hash] The body content of the SOAP response.
      def self.set_term_of_payment
        response = invoke('Creditor_SetTermOfPayment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether a creditor is accessible.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetIsAccessible
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_accessible
        response = invoke('Creditor_GetIsAccessible') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets whether a creditor is accessible.
      # Parameters: creditorHandle: Handle for the creditor. value: Value that indicates whether the creditor should be accessible.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetIsAccessible
      # @return [Hash] The body content of the SOAP response.
      def self.set_is_accessible
        response = invoke('Creditor_SetIsAccessible') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the Corporate Identification Number of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetCINumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_ci_number
        response = invoke('Creditor_GetCINumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the Corporate Identification Number of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. value: The new Corporate Identification Number of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetCINumber
      # @return [Hash] The body content of the SOAP response.
      def self.set_ci_number
        response = invoke('Creditor_SetCINumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the e-mail of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. value: The new email of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetEmail
      # @return [Hash] The body content of the SOAP response.
      def self.set_email
        response = invoke('Creditor_SetEmail') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Get the e-mail of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetEmail
      # @return [Hash] The body content of the SOAP response.
      def self.get_email
        response = invoke('Creditor_GetEmail') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the address of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. value: The new address of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetAddress
      # @return [Hash] The body content of the SOAP response.
      def self.set_address
        response = invoke('Creditor_SetAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the address of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetAddress
      # @return [Hash] The body content of the SOAP response.
      def self.get_address
        response = invoke('Creditor_GetAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the postal code of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.get_postal_code
        response = invoke('Creditor_GetPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the postal code of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. value: The new postal code of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.set_postal_code
        response = invoke('Creditor_SetPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the city of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. value: The new city of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetCity
      # @return [Hash] The body content of the SOAP response.
      def self.set_city
        response = invoke('Creditor_SetCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the city of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetCity
      # @return [Hash] The body content of the SOAP response.
      def self.get_city
        response = invoke('Creditor_GetCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the country of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetCountry
      # @return [Hash] The body content of the SOAP response.
      def self.get_country
        response = invoke('Creditor_GetCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the country of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. value: The new country of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetCountry
      # @return [Hash] The body content of the SOAP response.
      def self.set_country
        response = invoke('Creditor_SetCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the bank account of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. value: The new bank account of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetBankAccount
      # @return [Hash] The body content of the SOAP response.
      def self.set_bank_account
        response = invoke('Creditor_SetBankAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the bank account of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetBankAccount
      # @return [Hash] The body content of the SOAP response.
      def self.get_bank_account
        response = invoke('Creditor_GetBankAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the attention of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. valueHandle: Handle for new attention of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetAttention
      # @return [Hash] The body content of the SOAP response.
      def self.set_attention
        response = invoke('Creditor_SetAttention') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the attention of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetAttention
      # @return [Hash] The body content of the SOAP response.
      def self.get_attention
        response = invoke('Creditor_GetAttention') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for 'your reference' of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetYourReference
      # @return [Hash] The body content of the SOAP response.
      def self.get_your_reference
        response = invoke('Creditor_GetYourReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets 'your reference' of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. valueHandle: Handle for 'your reference' of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetYourReference
      # @return [Hash] The body content of the SOAP response.
      def self.set_your_reference
        response = invoke('Creditor_SetYourReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets 'our reference' of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. valueHandle: Handle for 'our reference' of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetOurReference
      # @return [Hash] The body content of the SOAP response.
      def self.set_our_reference
        response = invoke('Creditor_SetOurReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for 'our reference' of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetOurReference
      # @return [Hash] The body content of the SOAP response.
      def self.get_our_reference
        response = invoke('Creditor_GetOurReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the default payment type of a creditor. To set bank payment type, use CashBookEntry_SetRemittanceInformation.
      # Parameters: cashBookEntryHandle: Handle for the cash book entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetDefaultPaymentType
      # @return [Hash] The body content of the SOAP response.
      def self.get_default_payment_type
        response = invoke('Creditor_GetDefaultPaymentType') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the payment creditor id of a creditor. To set bank payment creditor id, use Creditor_SetRemittanceInformation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetDefaultPaymentCreditorId
      # @return [Hash] The body content of the SOAP response.
      def self.get_default_payment_creditor_id
        response = invoke('Creditor_GetDefaultPaymentCreditorId') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the County of a creditor. (UK only)
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetCounty
      # @return [Hash] The body content of the SOAP response.
      def self.get_county
        response = invoke('Creditor_GetCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the County of a creditor. (UK only)
      # Parameters: creditorHandle: Handle for the creditor. value: The new County of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetCounty
      # @return [Hash] The body content of the SOAP response.
      def self.set_county
        response = invoke('Creditor_SetCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the automatic contra account of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetAutoContraAccount
      # @return [Hash] The body content of the SOAP response.
      def self.get_auto_contra_account
        response = invoke('Creditor_GetAutoContraAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the automatic contra account of a creditor.
      # Parameters: creditorHandle: Handle for the creditor. valueHandle: Handle for new automatic contra account of the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_SetAutoContraAccount
      # @return [Hash] The body content of the SOAP response.
      def self.set_auto_contra_account
        response = invoke('Creditor_SetAutoContraAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Return handles for all creditors
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('Creditor_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Return handles for all creditors from date. fromDate is based on CET. includeCalculatedProperties is reserved for future usage and should be set to false for now.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetAllUpdated
      # @return [Hash] The body content of the SOAP response.
      def self.get_all_updated
        response = invoke('Creditor_GetAllUpdated') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handle for creditor with a given number.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_FindByNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_number
        response = invoke('Creditor_FindByNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an array with handles for the creditors corresponding to the given creditor numbers. If a creditor with a given number does not exist or if no number is given then the array contains nothing at that index.
      # Parameters: numbers: The numbers to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_FindByNumberList
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_number_list
        response = invoke('Creditor_FindByNumberList') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handle for creditors with a given name.
      # Parameters: The name to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_FindByName
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_name
        response = invoke('Creditor_FindByName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for creditor contacts of a creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetCreditorContacts
      # @return [Hash] The body content of the SOAP response.
      def self.get_creditor_contacts
        response = invoke('Creditor_GetCreditorContacts') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Deletes a creditor.
      # Parameters: creditorHandle: Handle for creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_Delete
      # @return [Hash] The body content of the SOAP response.
      def self.delete
        response = invoke('Creditor_Delete') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the entries of the creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetEntries
      # @return [Hash] The body content of the SOAP response.
      def self.get_entries
        response = invoke('Creditor_GetEntries') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the entries of the creditor that match the voucherNo.
      # Parameters: creditorHandle: Handle for the creditor. voucherNo: The voucher number you wish to filter by.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetEntriesByVoucherNo
      # @return [Hash] The body content of the SOAP response.
      def self.get_entries_by_voucher_no
        response = invoke('Creditor_GetEntriesByVoucherNo') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the entries of the creditor that match the invoiceNo.
      # Parameters: creditorHandle: Handle for the creditor. invoiceNo: The invoice number you wish to filter by.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetEntriesByInvoiceNo
      # @return [Hash] The body content of the SOAP response.
      def self.get_entries_by_invoice_no
        response = invoke('Creditor_GetEntriesByInvoiceNo') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the entries of the creditor that match both the vouher number and invoice number.
      # Parameters: creditorHandle: Handle for the creditor. voucherNo: The voucher number you wish to filter by. invoiceNo: The invoice number you wish to filter by.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetEntriesByVoucherNoAndInvoiceNo
      # @return [Hash] The body content of the SOAP response.
      def self.get_entries_by_voucher_no_and_invoice_no
        response = invoke('Creditor_GetEntriesByVoucherNoAndInvoiceNo') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the open entries of the creditor.
      # Parameters: creditorHandle: Handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetOpenEntries
      # @return [Hash] The body content of the SOAP response.
      def self.get_open_entries
        response = invoke('Creditor_GetOpenEntries') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new creditor from a data object.
      # Parameters: data: The data object that specifies the properties of the new creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_CreateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data
        response = invoke('Creditor_CreateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates new creditor from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new creditors.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('Creditor_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Update creditors from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('Creditor_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates a creditor from a data object.
      # Parameters: data: The data object.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data
        response = invoke('Creditor_UpdateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a creditor data object for a given creditor.
      # Parameters: entityHandle: A handle for the creditor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('Creditor_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns creditor data objects for a given set of creditor handles.
      # Parameters: entityHandles: An array of the creditor handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Creditor_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('Creditor_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
