module Ruconomic
  module API
    module CreditorContact
      extend Ruconomic::WebService

      # Creates a new creditor contact from a data object.
      # Parameters: data: The data object that specifies the properties of the new creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_CreateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data
        response = invoke('CreditorContact_CreateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates new creditor contacts from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new creditor contacts.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('CreditorContact_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Update creditor contacts from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('CreditorContact_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates a creditor contact from a data object.
      # Parameters: data: The data object.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data
        response = invoke('CreditorContact_UpdateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a creditor contact data object for a given creditor contact.
      # Parameters: entityHandle: A handle for the creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('CreditorContact_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns creditor contact data objects for a given set of creditor contact handles.
      # Parameters: entityHandles: An array of the creditor contact handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('CreditorContact_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the creditor of a creditor contact.
      # Parameters: creditorContactHandle: Handle for the creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_GetCreditor
      # @return [Hash] The body content of the SOAP response.
      def self.get_creditor
        response = invoke('CreditorContact_GetCreditor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the name of a creditor contact.
      # Parameters: creditorContactHandle: Handle for the creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_GetName
      # @return [Hash] The body content of the SOAP response.
      def self.get_name
        response = invoke('CreditorContact_GetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the name of a creditor contact.
      # Parameters: creditorContactHandle: Handle for the creditor contact. value: The new name of the creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_SetName
      # @return [Hash] The body content of the SOAP response.
      def self.set_name
        response = invoke('CreditorContact_SetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of a creditor contact.
      # Parameters: creditorContactHandle: Handle for the creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_GetNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_number
        response = invoke('CreditorContact_GetNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the telephone number of a creditor contact.
      # Parameters: creditorContactHandle: Handle for the creditor contact. value: The new telephone number of the creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_SetTelephoneNumber
      # @return [Hash] The body content of the SOAP response.
      def self.set_telephone_number
        response = invoke('CreditorContact_SetTelephoneNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the telephone number of a creditor contact.
      # Parameters: creditorContactHandle: Handle for the creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_GetTelephoneNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_telephone_number
        response = invoke('CreditorContact_GetTelephoneNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the email of a creditor contact.
      # Parameters: creditorContactHandle: Handle for the creditor contact. value: The new email of the creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_SetEmail
      # @return [Hash] The body content of the SOAP response.
      def self.set_email
        response = invoke('CreditorContact_SetEmail') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the email of a creditor contact.
      # Parameters: creditorContactHandle: Handle for the creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_GetEmail
      # @return [Hash] The body content of the SOAP response.
      def self.get_email
        response = invoke('CreditorContact_GetEmail') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the comments of a creditor contact.
      # Parameters: creditorContactHandle: Handle for the creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_GetComments
      # @return [Hash] The body content of the SOAP response.
      def self.get_comments
        response = invoke('CreditorContact_GetComments') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the comments of a creditor contact.
      # Parameters: creditorContactHandle: Handle for the creditor contact. value: The new comments of the creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_SetComments
      # @return [Hash] The body content of the SOAP response.
      def self.set_comments
        response = invoke('CreditorContact_SetComments') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the external ID of a creditor contact.
      # Parameters: creditorContactHandle: Handle for the creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_GetExternalId
      # @return [Hash] The body content of the SOAP response.
      def self.get_external_id
        response = invoke('CreditorContact_GetExternalId') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the external ID of a creditor contact.
      # Parameters: creditorContactHandle: Handle for the creditor contact. value: The new external ID of the creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_SetExternalId
      # @return [Hash] The body content of the SOAP response.
      def self.set_external_id
        response = invoke('CreditorContact_SetExternalId') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_Create
      # @return [Hash] The body content of the SOAP response.
      def self.create
        response = invoke('CreditorContact_Create') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all creditor contacts.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('CreditorContact_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for creditor contacts with the given name.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_FindByName
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_name
        response = invoke('CreditorContact_FindByName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Deletes a creditor contact.
      # Parameters: creditorContactHandle: Handle for the creditor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorContact_Delete
      # @return [Hash] The body content of the SOAP response.
      def self.delete
        response = invoke('CreditorContact_Delete') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
