module Ruconomic
  module API
    module CreditorEntry
      extend Ruconomic::WebService

      # Gets the currency of the creditor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_currency
        response = invoke('CreditorEntry_GetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the currency amount of the creditor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_amount
        response = invoke('CreditorEntry_GetAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the invoice number of the creditor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetInvoiceNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_invoice_number
        response = invoke('CreditorEntry_GetInvoiceNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the due date of the creditor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetDueDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_due_date
        response = invoke('CreditorEntry_GetDueDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the currency remainder of the creditor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetRemainder
      # @return [Hash] The body content of the SOAP response.
      def self.get_remainder
        response = invoke('CreditorEntry_GetRemainder') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the remainder of the creditor entry in the default currency.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetRemainderDefaultCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_remainder_default_currency
        response = invoke('CreditorEntry_GetRemainderDefaultCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an array of handles for the creditor entries with numbers in the given interval.
      # Parameters: from: The beginning of the interval. to: the end of the interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_FindBySerialNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_serial_number
        response = invoke('CreditorEntry_FindBySerialNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an array of handles for the creditor entries with numbers filtered by serial number, entry type, invoice numbers.
      # Parameters: fromSerialNumber: The beginning of the interval. Use null to omit this filter. toSerialNumber: the end of the interval. Use null to omit this filter. entryType: Entry type. invoiceNumbers: Invoice Numbers. Array may also contain null as an entry to search for entries with no invoice number. Use null to omit this filter.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_FindBySerialNumberTypeAndInvoiceNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_serial_number_type_and_invoice_number
        response = invoke('CreditorEntry_FindBySerialNumberTypeAndInvoiceNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an array of handles for the creditor entries with the specified invoice number.
      # Parameters: invoiceNumber: The invoice number to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_FindByInvoiceNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_invoice_number
        response = invoke('CreditorEntry_FindByInvoiceNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Matches the entries passed to the function. No return value.
      # Parameters: entries: The creditor entries to be matched.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_MatchEntries
      # @return [Hash] The body content of the SOAP response.
      def self.match_entries
        response = invoke('CreditorEntry_MatchEntries') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a creditor entry data object for a given creditor entry.
      # Parameters: entityHandle: A handle for the creditor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('CreditorEntry_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns creditor entry data objects for a given set of creditor entry handles.
      # Parameters: entityHandles: An array of the creditor entry handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('CreditorEntry_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of the creditor entry.
      # Parameters: creditorentryHandle: Handle for the creditor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetSerialNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_serial_number
        response = invoke('CreditorEntry_GetSerialNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the entry type of the creditor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetType
      # @return [Hash] The body content of the SOAP response.
      def self.get_type
        response = invoke('CreditorEntry_GetType') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the date of the creditor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_date
        response = invoke('CreditorEntry_GetDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the creditor of the creditor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetCreditor
      # @return [Hash] The body content of the SOAP response.
      def self.get_creditor
        response = invoke('CreditorEntry_GetCreditor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the account of the creditor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetAccount
      # @return [Hash] The body content of the SOAP response.
      def self.get_account
        response = invoke('CreditorEntry_GetAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the voucher number of the creditor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetVoucherNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_voucher_number
        response = invoke('CreditorEntry_GetVoucherNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the text of the creditor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetText
      # @return [Hash] The body content of the SOAP response.
      def self.get_text
        response = invoke('CreditorEntry_GetText') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the amount of the creditor entry in the default currency.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CreditorEntry_GetAmountDefaultCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_amount_default_currency
        response = invoke('CreditorEntry_GetAmountDefaultCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
