module Ruconomic
  module API
    module CurrentInvoice
      extend Ruconomic::WebService

      # Gets whether the current invoice has VAT included.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetIsVatIncluded
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_vat_included
        response = invoke('CurrentInvoice_GetIsVatIncluded') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set whether the current invoice has VAT included.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. valueHandle: Handle for the new layout of the current invoice. value: value indicating whether the current invoice includes VAT or not.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetIsVatIncluded
      # @return [Hash] The body content of the SOAP response.
      def self.set_is_vat_included
        response = invoke('CurrentInvoice_SetIsVatIncluded') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the current VAT zone of the CurrentInvoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetVatZone
      # @return [Hash] The body content of the SOAP response.
      def self.get_vat_zone
        response = invoke('CurrentInvoice_GetVatZone') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the VAT zone of the CurrentInvoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. valueHandle: Handle for the new VAT zone of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetVatZone
      # @return [Hash] The body content of the SOAP response.
      def self.set_vat_zone
        response = invoke('CurrentInvoice_SetVatZone') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the layout of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetLayout
      # @return [Hash] The body content of the SOAP response.
      def self.get_layout
        response = invoke('CurrentInvoice_GetLayout') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the layout of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. valueHandle: Handle for the new layout of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetLayout
      # @return [Hash] The body content of the SOAP response.
      def self.set_layout
        response = invoke('CurrentInvoice_SetLayout') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the delivery location of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDeliveryLocation
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_location
        response = invoke('CurrentInvoice_GetDeliveryLocation') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the delivery location of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. valueHandle: Handle for the new delivery location of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDeliveryLocation
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_location
        response = invoke('CurrentInvoice_SetDeliveryLocation') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery address of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDeliveryAddress
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_address
        response = invoke('CurrentInvoice_GetDeliveryAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the delivery address of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new delivery address of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDeliveryAddress
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_address
        response = invoke('CurrentInvoice_SetDeliveryAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery postal code of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDeliveryPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_postal_code
        response = invoke('CurrentInvoice_GetDeliveryPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the delivery postal code of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new delivery postal code of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDeliveryPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_postal_code
        response = invoke('CurrentInvoice_SetDeliveryPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery city of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDeliveryCity
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_city
        response = invoke('CurrentInvoice_GetDeliveryCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the delivery city of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new delivery city of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDeliveryCity
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_city
        response = invoke('CurrentInvoice_SetDeliveryCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery country of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDeliveryCountry
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_country
        response = invoke('CurrentInvoice_GetDeliveryCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the delivery country of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new delivery country of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDeliveryCountry
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_country
        response = invoke('CurrentInvoice_SetDeliveryCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the terms of delivery of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetTermsOfDelivery
      # @return [Hash] The body content of the SOAP response.
      def self.get_terms_of_delivery
        response = invoke('CurrentInvoice_GetTermsOfDelivery') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the terms of delivery of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the currentInvoice. value: The new terms of delivery of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetTermsOfDelivery
      # @return [Hash] The body content of the SOAP response.
      def self.set_terms_of_delivery
        response = invoke('CurrentInvoice_SetTermsOfDelivery') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery date of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDeliveryDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_date
        response = invoke('CurrentInvoice_GetDeliveryDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the delivery date of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new delivery date of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDeliveryDate
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_date
        response = invoke('CurrentInvoice_SetDeliveryDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the heading of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetHeading
      # @return [Hash] The body content of the SOAP response.
      def self.get_heading
        response = invoke('CurrentInvoice_GetHeading') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the heading of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new heading of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetHeading
      # @return [Hash] The body content of the SOAP response.
      def self.set_heading
        response = invoke('CurrentInvoice_SetHeading') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the primary line of text of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetTextLine1
      # @return [Hash] The body content of the SOAP response.
      def self.get_text_line1(id)
        response = invoke('CurrentInvoice_GetTextLine1') do |message|
          message.add 'currentInvoiceHandle' do |handle|
            handle.add 'Id', id
          end
        end

        response.fetch(:current_invoice_get_text_line1_response, :current_invoice_get_text_line1_result)
      end

      # Set the primary line of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new primary line of text of the current invoice.
      #
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetTextLine1
      # @return [Hash] The body content of the SOAP response.
      def self.set_text_line1(id, text)
        response = invoke('CurrentInvoice_SetTextLine1') do |message|
          message.add 'currentInvoiceHandle' do |handle|
            handle.add 'Id', id
          end
          message.add 'value', text
        end

        response.fetch(:current_invoice_set_text_line1)
      end

      # Gets the secondary line of text of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetTextLine2
      # @return [Hash] The body content of the SOAP response.
      def self.get_text_line2
        response = invoke('CurrentInvoice_GetTextLine2') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the secondary line of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new secondary line of text of the current invoice.
      #
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetTextLine2
      # @return [Hash] The body content of the SOAP response.
      def self.set_text_line2(id, text)
        response = invoke('CurrentInvoice_SetTextLine2') do |message|
          message.add 'currentInvoiceHandle' do |handle|
            handle.add 'Id', id
          end
          message.add 'value', text
        end

        response.fetch(:current_invoice_set_text_line2)
      end

      # Gets the other reference of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetOtherReference
      # @return [Hash] The body content of the SOAP response.
      def self.get_other_reference
        response = invoke('CurrentInvoice_GetOtherReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the other reference of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new other reference of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetOtherReference
      # @return [Hash] The body content of the SOAP response.
      def self.set_other_reference
        response = invoke('CurrentInvoice_SetOtherReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the total amount for all the lines without VAT if the current invoice (in the currency of that current invoice).
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetNetAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_net_amount
        response = invoke('CurrentInvoice_GetNetAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the total VAT amount for all the lines of a current invoice (in the currency of that current invoice).
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetVatAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_vat_amount
        response = invoke('CurrentInvoice_GetVatAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the total gross amount for all the lines of a current invoice (in the currency of that current invoice).
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetGrossAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_gross_amount
        response = invoke('CurrentInvoice_GetGrossAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the margin of a current invoice (in the currency of that current invoice).
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetMargin
      # @return [Hash] The body content of the SOAP response.
      def self.get_margin
        response = invoke('CurrentInvoice_GetMargin') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the margin of a current invoice as percent.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetMarginAsPercent
      # @return [Hash] The body content of the SOAP response.
      def self.get_margin_as_percent
        response = invoke('CurrentInvoice_GetMarginAsPercent') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the rounding amount for all lines of the current invoice (in the currency of the invoice).
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetRoundingAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_rounding_amount
        response = invoke('CurrentInvoice_GetRoundingAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the DebtorCounty of a current invoice. (UK only)
      # Parameters: currentInvoiceHandle: Handle for the currentInvoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDebtorCounty
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_county
        response = invoke('CurrentInvoice_GetDebtorCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the DebtorCounty of a current invoice. (UK only)
      # Parameters: currentInvoiceHandle: Handle for the currentInvoice. value: The new DebtorCounty of the currentInvoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDebtorCounty
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_county
        response = invoke('CurrentInvoice_SetDebtorCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the DeliveryCounty of a current invoice. (UK only)
      # Parameters: currentInvoiceHandle: Handle for the currentInvoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDeliveryCounty
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_county
        response = invoke('CurrentInvoice_GetDeliveryCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the DeliveryCounty of a current invoice. (UK only)
      # Parameters: currentInvoiceHandle: Handle for the currentInvoice. value: The new DeliveryCounty of the currentInvoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDeliveryCounty
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_county
        response = invoke('CurrentInvoice_SetDeliveryCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the deduction amount of the current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDeductionAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_deduction_amount
        response = invoke('CurrentInvoice_GetDeductionAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new current invoice from a data object.
      # Parameters: data: The data object that specifies the properties of the new current invoice.
      # returns [String] with the created invoices id
      def self.create_from_data(invoice_data)
        response = invoke('CurrentInvoice_CreateFromData') do |message|
          message.add 'data' do |data|
            data.add('Id', invoice_data.dig(:id))
            data.add_handle('DebtorHandle', invoice_data.dig(:debtor_handle, :number))
            data.add('DebtorName', invoice_data.dig(:debtor_name))
            data.add_optional('DebtorAddress', invoice_data.dig(:debtor_address))
            data.add_optional('DebtorPostalCode', invoice_data.dig(:debtor_postal_code))
            data.add_optional('DebtorCity', invoice_data.dig(:debtor_city))
            data.add_optional('DebtorCountry', invoice_data.dig(:debtor_country))
            data.add_optional('DebtorEan', invoice_data.dig(:debtor_ean))
            data.add_handle('AttentionHandle', invoice_data.dig(:attention_handle, :id), 'Id')
            data.add_handle('YourReferenceHandle', invoice_data.dig(:your_reference_handle, :id), 'Id')
            data.add('Date', invoice_data.dig(:date))
            data.add_handle('TermOfPaymentHandle', invoice_data.dig(:term_of_payment_handle, :id), 'Id')
            data.add('DueDate', invoice_data.dig(:due_date))
            data.add_handle('CurrencyHandle', invoice_data.dig(:currency_handle, :code), 'Code')
            data.add_optional('ExchangeRate', invoice_data.dig(:exchange_rate))
            data.add('IsVatIncluded', invoice_data.dig(:is_vat_included))
            data.add_handle('LayoutHandle', invoice_data.dig(:layout_handle, :id), 'Id')
            data.add('DeliveryDate', invoice_data.dig(:delivery_date))
            data.add_optional('Heading', invoice_data.dig(:heading))
            data.add_optional('TextLine1', invoice_data.dig(:text_line1))
            data.add_optional('TextLine2', invoice_data.dig(:text_line2))
            data.add('NetAmount', invoice_data.dig(:net_amount))
            data.add('VatAmount', invoice_data.dig(:vat_amount))
            data.add('GrossAmount', invoice_data.dig(:gross_amount))
            data.add('Margin', invoice_data.dig(:margin))
            data.add('MarginAsPercent', invoice_data.dig(:margin_as_percent))
          end
        end

        response.to_hash.dig(
          :current_invoice_create_from_data_response,
          :current_invoice_create_from_data_result,
          :id
        )
      end

      # Creates new current invoices from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new current invoices.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('CurrentInvoice_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Update current invoices from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('CurrentInvoice_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates a current invoice from a data object.
      # Parameters: data: The data object.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data
        response = invoke('CurrentInvoice_UpdateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a current invoice data object for a given current invoice.
      # Parameters: entityHandle: A handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data(id)
        response = invoke('CurrentInvoice_GetData') do |message|
          message.add 'entityHandle' do |handle|
            handle.add 'Id', id
          end
        end

        response.fetch(:current_invoice_get_data_response, :current_invoice_get_data_result)
      end

      # Returns current invoice data objects for a given set of current invoice handles.
      # Parameters: entityHandles: An array of the current invoice handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('CurrentInvoice_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new current invoice.
      # Parameters: debtor: Handle for a debitor.
      # @param Number [String] Debtor number
      # @return [String] The created invoice id
      def self.create(number)
        response = invoke('CurrentInvoice_Create') do |message|
          message.add 'debtorHandle' do |handle|
            handle.add 'Number', number
          end
        end

        response.fetch(:current_invoice_create_response, :current_invoice_create_result, :id)
      end

      # Returns handles for all current invoices.
      #
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('CurrentInvoice_GetAll')

        response.fetch(:current_invoice_get_all_response, :current_invoice_get_all_result)
      end

      # Returns handles for the current invoices which have the given employee as OurReference.
      # Parameters: ourReferenceHandle: Handle for the employee to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_FindByOurReference
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_our_reference
        response = invoke('CurrentInvoice_FindByOurReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for the current invoices with a given other reference.
      # Parameters: otherReference: The other reference to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_FindByOtherReference
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_other_reference
        response = invoke('CurrentInvoice_FindByOtherReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for current invoices in a given interval of days.
      # Parameters: first: First day in interval. last: Last day in interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_FindByDateInterval
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_date_interval
        response = invoke('CurrentInvoice_FindByDateInterval') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Return handles for all current invoices from date. FromDate is based on CET.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetAllUpdated
      # @return [Hash] The body content of the SOAP response.
      def self.get_all_updated
        response = invoke('CurrentInvoice_GetAllUpdated') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a current invoice as a PDF file.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetPdf
      # @return [Hash] The body content of the SOAP response.
      def self.get_pdf
        response = invoke('CurrentInvoice_GetPdf') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Books a current invoice. An invoice number greater than all other invoice numbers will be assigned to the resulting invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_Book
      # @return [Hash] The body content of the SOAP response.
      def self.book(id)
        response = invoke('CurrentInvoice_Book') do |message|
          message.add 'currentInvoiceHandle' do |handle|
            handle.add 'Id', id
          end
        end

        response.fetch(:current_invoice_book_response, :current_invoice_book_result, :number)
      end

      # Books a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. number: The invoice number of the resulting invoice; must be positive and different from all other invoice numbers.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_BookWithNumber
      # @return [Hash] The body content of the SOAP response.
      def self.book_with_number
        response = invoke('CurrentInvoice_BookWithNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Deletes a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_Delete
      # @return [] The body content of the SOAP response.
      def self.delete(id)
        response = invoke('CurrentInvoice_Delete') do |message|
          message.add 'currentInvoiceHandle' do |handle|
            handle.add 'Id', id
          end
        end

        response.fetch(:current_invoice_delete_response)
      end

      # Gets handles for the lines of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetLines
      # @return [Hash] The body content of the SOAP response.
      def self.get_lines
        response = invoke('CurrentInvoice_GetLines') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handle for the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor
        response = invoke('CurrentInvoice_GetDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. valueHandle: Handle for the new debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor
        response = invoke('CurrentInvoice_SetDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the project of a current invoice.
      # Parameters: invoiceHandle: Handle for the invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetProject
      # @return [Hash] The body content of the SOAP response.
      def self.get_project
        response = invoke('CurrentInvoice_GetProject') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the project of a current invoice.
      # Parameters: invoiceHandle: Handle for the invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetProject
      # @return [Hash] The body content of the SOAP response.
      def self.set_project
        response = invoke('CurrentInvoice_SetProject') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the name of the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDebtorName
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_name
        response = invoke('CurrentInvoice_GetDebtorName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the name of the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new name of the debtor of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDebtorName
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_name
        response = invoke('CurrentInvoice_SetDebtorName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the address of the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDebtorAddress
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_address
        response = invoke('CurrentInvoice_GetDebtorAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the address of the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new name of the debtor of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDebtorAddress
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_address
        response = invoke('CurrentInvoice_SetDebtorAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the postal code of the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDebtorPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_postal_code
        response = invoke('CurrentInvoice_GetDebtorPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the postal code of the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new postal code of the debtor of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDebtorPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_postal_code
        response = invoke('CurrentInvoice_SetDebtorPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the city of the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDebtorCity
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_city
        response = invoke('CurrentInvoice_GetDebtorCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the city of the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new city of the debtor of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDebtorCity
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_city
        response = invoke('CurrentInvoice_SetDebtorCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the country of the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDebtorCountry
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_country
        response = invoke('CurrentInvoice_GetDebtorCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the country of the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new country of the debtor of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDebtorCountry
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_country
        response = invoke('CurrentInvoice_SetDebtorCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the European Article Number of the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDebtorEan
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_ean
        response = invoke('CurrentInvoice_GetDebtorEan') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the European Article Number of the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new EAN of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDebtorEan
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_ean
        response = invoke('CurrentInvoice_SetDebtorEan') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the public entry number of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetPublicEntryNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_public_entry_number
        response = invoke('CurrentInvoice_GetPublicEntryNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the public entry number of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new public entry number of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetPublicEntryNumber
      # @return [Hash] The body content of the SOAP response.
      def self.set_public_entry_number
        response = invoke('CurrentInvoice_SetPublicEntryNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the attention of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetAttention
      # @return [Hash] The body content of the SOAP response.
      def self.get_attention
        response = invoke('CurrentInvoice_GetAttention') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the attention of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. valueHandle: Handle for the new attention of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetAttention
      # @return [Hash] The body content of the SOAP response.
      def self.set_attention
        response = invoke('CurrentInvoice_SetAttention') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the reference of the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetYourReference
      # @return [Hash] The body content of the SOAP response.
      def self.get_your_reference
        response = invoke('CurrentInvoice_GetYourReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the the reference for the debtor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. valueHandle: Handle for the new reference for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetYourReference
      # @return [Hash] The body content of the SOAP response.
      def self.set_your_reference
        response = invoke('CurrentInvoice_SetYourReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the primary reference of the creditor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetOurReference
      # @return [Hash] The body content of the SOAP response.
      def self.get_our_reference
        response = invoke('CurrentInvoice_GetOurReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the the primary reference of the creditor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. valueHandle: Handle for the new primary reference of the creditor of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetOurReference
      # @return [Hash] The body content of the SOAP response.
      def self.set_our_reference
        response = invoke('CurrentInvoice_SetOurReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the secondary reference of the creditor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetOurReference2
      # @return [Hash] The body content of the SOAP response.
      def self.get_our_reference2
        response = invoke('CurrentInvoice_GetOurReference2') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the the secondary reference of the creditor of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. valueHandle: Handle for the new secondary reference of the creditor of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetOurReference2
      # @return [Hash] The body content of the SOAP response.
      def self.set_our_reference2
        response = invoke('CurrentInvoice_SetOurReference2') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the date of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_date
        response = invoke('CurrentInvoice_GetDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the date of a current invoice. The due date is calculated accordingly as specified by the term of payment.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new date of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDate
      # @return [Hash] The body content of the SOAP response.
      def self.set_date
        response = invoke('CurrentInvoice_SetDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the term of payment of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetTermOfPayment
      # @return [Hash] The body content of the SOAP response.
      def self.get_term_of_payment
        response = invoke('CurrentInvoice_GetTermOfPayment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the term of payment of a current invoice. The due date is calculated accordingly.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. valueHandle: Handle for the new term of payment of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetTermOfPayment
      # @return [Hash] The body content of the SOAP response.
      def self.set_term_of_payment
        response = invoke('CurrentInvoice_SetTermOfPayment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the due date of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetDueDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_due_date
        response = invoke('CurrentInvoice_GetDueDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the due date of a current invoice. It is only allowed to set the due date to an actual date when the type of TermOfPayment is set to DueDate.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. value: The new due date of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetDueDate
      # @return [Hash] The body content of the SOAP response.
      def self.set_due_date(id, due_date)
        response = invoke('CurrentInvoice_SetDueDate') do |message|
          message.add 'currentInvoiceHandle' do |handle|
            handle.add 'Id', id
          end
          message.add 'value', due_date
        end

        response.fetch(:current_invoice_set_due_date_response)
      end

      # Gets the currency of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_currency
        response = invoke('CurrentInvoice_GetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the currency of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. valueHandle: Handle for the new currency of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.set_currency
        response = invoke('CurrentInvoice_SetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the exchange rate of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_GetExchangeRate
      # @return [Hash] The body content of the SOAP response.
      def self.get_exchange_rate
        response = invoke('CurrentInvoice_GetExchangeRate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the exchange rate of a current invoice.
      # Parameters: currentInvoiceHandle: Handle for the current invoice. valueHandle: New exchange of the current invoice.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=CurrentInvoice_SetExchangeRate
      # @return [Hash] The body content of the SOAP response.
      def self.set_exchange_rate
        response = invoke('CurrentInvoice_SetExchangeRate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
