module Ruconomic
  module API
    module Debtor
      extend Ruconomic::WebService

      # Gets the extended VAT zone of the given debitor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetExtendedVatZone
      # @return [Hash] The body content of the SOAP response.
      def self.get_extended_vat_zone
        response = invoke('Debtor_GetExtendedVatZone') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets extended VAT zone of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: Handle for new extended vat zone of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetExtendedVatZone
      # @return [Hash] The body content of the SOAP response.
      def self.set_extended_vat_zone
        response = invoke('Debtor_SetExtendedVatZone') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handle for debtors with a given email.
      # Parameters: The email to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_FindByEmail
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_email
        response = invoke('Debtor_FindByEmail') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for debtors with a given EAN.
      # Parameters: The EAN to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_FindByEan
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_ean
        response = invoke('Debtor_FindByEan') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for debtors with a given Corporate Identification Number.
      # Parameters: The Corporate Identification Number to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_FindByCINumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_ci_number
        response = invoke('Debtor_FindByCINumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handle for debtors with a given telephone and fax number.
      # Parameters: The telephone and fax number to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_FindByTelephoneAndFaxNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_telephone_and_fax_number
        response = invoke('Debtor_FindByTelephoneAndFaxNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for delivery locations of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetDeliveryLocations
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_locations
        response = invoke('Debtor_GetDeliveryLocations') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for debtor contacts of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetDebtorContacts
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_contacts
        response = invoke('Debtor_GetDebtorContacts') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the invoices of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetInvoices
      # @return [Hash] The body content of the SOAP response.
      def self.get_invoices
        response = invoke('Debtor_GetInvoices') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the orders of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetOrders
      # @return [Hash] The body content of the SOAP response.
      def self.get_orders
        response = invoke('Debtor_GetOrders') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the current invoices of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetCurrentInvoices
      # @return [Hash] The body content of the SOAP response.
      def self.get_current_invoices
        response = invoke('Debtor_GetCurrentInvoices') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the quotations of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetQuotations
      # @return [Hash] The body content of the SOAP response.
      def self.get_quotations
        response = invoke('Debtor_GetQuotations') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the entries of the debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetEntries
      # @return [Hash] The body content of the SOAP response.
      def self.get_entries
        response = invoke('Debtor_GetEntries') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the open entries of the debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetOpenEntries
      # @return [Hash] The body content of the SOAP response.
      def self.get_open_entries
        response = invoke('Debtor_GetOpenEntries') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the subscribers of the debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetSubscribers
      # @return [Hash] The body content of the SOAP response.
      def self.get_subscribers
        response = invoke('Debtor_GetSubscribers') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Deletes a debtor.
      #
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_Delete
      # @param handle [String] Handle for debtor.
      # @return [Nil]
      def self.delete(handle)
        response = invoke('Debtor_Delete') do |message|
          message.add 'debtorHandle' do |number|
            number.add 'Number', handle
          end
        end

        nil
      end

      # Creates a new debtor from a data object.
      # Parameters: data: The data object that specifies the properties of the new debtor.
      #
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_CreateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data(debtor_data)
        response = invoke('Debtor_CreateFromData') do |message|
          message.add 'data' do |data|
            data.add_handle('Handle', debtor_data.dig(:handle, :number))
            data.add('Number', debtor_data.dig(:number))
            data.add_handle('DebtorGroupHandle', debtor_data.dig(:debtor_group_handle, :number))
            data.add('Name', debtor_data.dig(:name))
            data.add('VatZone', debtor_data.dig(:vat_zone))
            data.add_handle('ExtendedVatZone', debtor_data.dig(:extended_vat_zone, :number))
            data.add_handle('CurrencyHandle', debtor_data.dig(:currency_handle, :code), 'Code')
            data.add_handle('PriceGroupHandle', debtor_data.dig(:price_group_handle, :number))
            data.add('IsAccessible', debtor_data.dig(:is_accessible))
            data.add_optional('Ean', debtor_data.dig(:ean))
            data.add_optional('PublicEntryNumber', debtor_data.dig(:public_entry_number))
            data.add_optional('Email', debtor_data.dig(:email))
            data.add_optional('TelephoneAndFaxNumber', debtor_data.dig(:telephone_and_fax_number))
            data.add_optional('Website', debtor_data.dig(:website))
            data.add_optional('Address', debtor_data.dig(:address))
            data.add_optional('PostalCode', debtor_data.dig(:postal_code))
            data.add_optional('City', debtor_data.dig(:city))
            data.add_optional('Country', debtor_data.dig(:country))
            data.add_optional('CreditMaximum', debtor_data.dig(:credit_maximum))
            data.add_optional('VatNumber', debtor_data.dig(:vat_number))
            data.add_optional('CINumber', debtor_data.dig(:ci_number))
            data.add_handle('TermOfPaymentHandle', debtor_data.dig(:term_of_payment_handle, :id), 'Id')
            data.add_handle('LayoutHandle', debtor_data.dig(:layout_handle, :id), 'Id')
            data.add_handle('AttentionHandle', debtor_data.dig(:attention_handle, :id), 'Id')
            data.add_handle('YourReferenceHandle', debtor_data.dig(:your_reference_handle, :id), 'Id')
            data.add_handle('OurReferenceHandle', debtor_data.dig(:our_reference_handle, :number))
            data.add_optional('Balance', debtor_data.dig(:balance))
            data.add_handle('DefaultDeliveryLocationHandle', debtor_data.dig(:default_delivery_location_handle, :id), 'Id')
          end
        end

        response.to_hash.dig(
          :debtor_create_from_data_response,
          :debtor_create_from_data_result,
          :number
        )
      end

      # Creates new debtors from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new debtors.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('Debtor_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Update debtors from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('Debtor_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates a debtor from a data object.
      # Parameters: data: The data object.
      #
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data(debtor_data)
        response = invoke('Debtor_UpdateFromData') do |message|
          message.add 'data' do |data|
            data.add_handle('Handle', debtor_data.dig(:handle, :number))
            data.add('Number', debtor_data.dig(:number))
            data.add_handle('DebtorGroupHandle', debtor_data.dig(:debtor_group_handle, :number))
            data.add('Name', debtor_data.dig(:name))
            data.add('VatZone', debtor_data.dig(:vat_zone))
            data.add_handle('ExtendedVatZone', debtor_data.dig(:extended_vat_zone, :number))
            data.add_handle('CurrencyHandle', debtor_data.dig(:currency_handle, :code), 'Code')
            data.add_handle('PriceGroupHandle', debtor_data.dig(:price_group_handle, :number))
            data.add('IsAccessible', debtor_data.dig(:is_accessible))
            data.add_optional('Ean', debtor_data.dig(:ean))
            data.add_optional('PublicEntryNumber', debtor_data.dig(:public_entry_number))
            data.add_optional('Email', debtor_data.dig(:email))
            data.add_optional('TelephoneAndFaxNumber', debtor_data.dig(:telephone_and_fax_number))
            data.add_optional('Website', debtor_data.dig(:website))
            data.add_optional('Address', debtor_data.dig(:address))
            data.add_optional('PostalCode', debtor_data.dig(:postal_code))
            data.add_optional('City', debtor_data.dig(:city))
            data.add_optional('Country', debtor_data.dig(:country))
            data.add_optional('CreditMaximum', debtor_data.dig(:credit_maximum))
            data.add_optional('VatNumber', debtor_data.dig(:vat_number))
            data.add_optional('CINumber', debtor_data.dig(:ci_number))
            data.add_handle('TermOfPaymentHandle', debtor_data.dig(:term_of_payment_handle, :id), 'Id')
            data.add_handle('LayoutHandle', debtor_data.dig(:layout_handle, :id), 'Id')
            data.add_handle('AttentionHandle', debtor_data.dig(:attention_handle, :id), 'Id')
            data.add_handle('YourReferenceHandle', debtor_data.dig(:your_reference_handle, :id), 'Id')
            data.add_handle('OurReferenceHandle', debtor_data.dig(:our_reference_handle, :number))
            data.add_optional('Balance', debtor_data.dig(:balance))
            data.add_handle('DefaultDeliveryLocationHandle', debtor_data.dig(:default_delivery_location_handle, :id), 'Id')
          end
        end

        response.fetch(:debtor_update_from_data_response, :debtor_update_from_data_result, :number)
      end

      # Returns a debtor data object for a given debtor.
      #
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetData
      # @param entityHandle [String] A handle for the debtor.
      # @return [Hash] The debtor data.
      def self.get_data(entityHandle)
        response = invoke('Debtor_GetData') do |message|
          message.add 'entityHandle' do |number|
            number.add 'Number', entityHandle
          end
        end

        response.fetch(:debtor_get_data_response, :debtor_get_data_result)
      end

      # Returns debtor data objects for a given set of debtor handles.
      # Parameters: entityHandles: An array of the debtor handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('Debtor_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_number
        response = invoke('Debtor_GetNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor group of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. valueHandle: Handle for new debtor group of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetDebtorGroup
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_group
        response = invoke('Debtor_SetDebtorGroup') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handle for debtor group of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetDebtorGroup
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_group
        response = invoke('Debtor_GetDebtorGroup') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the name of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetName
      # @return [Hash] The body content of the SOAP response.
      def self.get_name
        response = invoke('Debtor_GetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the name of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: The new name of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetName
      # @return [Hash] The body content of the SOAP response.
      def self.set_name
        response = invoke('Debtor_SetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets vat zone of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: Handle for new vat zone of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetVatZone
      # @return [Hash] The body content of the SOAP response.
      def self.set_vat_zone
        response = invoke('Debtor_SetVatZone') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handle for vat zone of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetVatZone
      # @return [Hash] The body content of the SOAP response.
      def self.get_vat_zone
        response = invoke('Debtor_GetVatZone') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets currency of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_currency
        response = invoke('Debtor_GetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets currency of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: Handle for new currency of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.set_currency
        response = invoke('Debtor_SetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the price group of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: Handle for the new price group of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetPriceGroup
      # @return [Hash] The body content of the SOAP response.
      def self.set_price_group
        response = invoke('Debtor_SetPriceGroup') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the price group of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetPriceGroup
      # @return [Hash] The body content of the SOAP response.
      def self.get_price_group
        response = invoke('Debtor_GetPriceGroup') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets whether a debtor is accessible.
      # Parameters: debtorHandle: Handle for the debtor. value: Value that indicates whether the debtor should be accessible.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetIsAccessible
      # @return [Hash] The body content of the SOAP response.
      def self.set_is_accessible
        response = invoke('Debtor_SetIsAccessible') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether a debtor is accessible.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetIsAccessible
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_accessible
        response = invoke('Debtor_GetIsAccessible') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets EAN of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetEan
      # @return [Hash] The body content of the SOAP response.
      def self.get_ean
        response = invoke('Debtor_GetEan') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets EAN of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: The new EAN of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetEan
      # @return [Hash] The body content of the SOAP response.
      def self.set_ean
        response = invoke('Debtor_SetEan') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the public entry number of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetPublicEntryNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_public_entry_number
        response = invoke('Debtor_GetPublicEntryNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the public entry number of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: The new public entry number of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetPublicEntryNumber
      # @return [Hash] The body content of the SOAP response.
      def self.set_public_entry_number
        response = invoke('Debtor_SetPublicEntryNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Get the email of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetEmail
      # @return [Hash] The body content of the SOAP response.
      def self.get_email
        response = invoke('Debtor_GetEmail') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the email of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: The new email of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetEmail
      # @return [Hash] The body content of the SOAP response.
      def self.set_email
        response = invoke('Debtor_SetEmail') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the telephone and fax number of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: The new telephone and fax number of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetTelephoneAndFaxNumber
      # @return [Hash] The body content of the SOAP response.
      def self.set_telephone_and_fax_number
        response = invoke('Debtor_SetTelephoneAndFaxNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the telephone and fax number of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetTelephoneAndFaxNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_telephone_and_fax_number
        response = invoke('Debtor_GetTelephoneAndFaxNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the website of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: The new website of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetWebsite
      # @return [Hash] The body content of the SOAP response.
      def self.set_website
        response = invoke('Debtor_SetWebsite') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the website of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetWebsite
      # @return [Hash] The body content of the SOAP response.
      def self.get_website
        response = invoke('Debtor_GetWebsite') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the address of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetAddress
      # @return [Hash] The body content of the SOAP response.
      def self.get_address
        response = invoke('Debtor_GetAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the address of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: The new address of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetAddress
      # @return [Hash] The body content of the SOAP response.
      def self.set_address
        response = invoke('Debtor_SetAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the postal code of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.get_postal_code
        response = invoke('Debtor_GetPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the postal code of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: The new postal code of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.set_postal_code
        response = invoke('Debtor_SetPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the city of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetCity
      # @return [Hash] The body content of the SOAP response.
      def self.get_city
        response = invoke('Debtor_GetCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the city of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: The new city of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetCity
      # @return [Hash] The body content of the SOAP response.
      def self.set_city
        response = invoke('Debtor_SetCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the country of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: The new country of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetCountry
      # @return [Hash] The body content of the SOAP response.
      def self.set_country
        response = invoke('Debtor_SetCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the country of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetCountry
      # @return [Hash] The body content of the SOAP response.
      def self.get_country
        response = invoke('Debtor_GetCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the credit maximum of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: The new credit maximum of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetCreditMaximum
      # @return [Hash] The body content of the SOAP response.
      def self.set_credit_maximum
        response = invoke('Debtor_SetCreditMaximum') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the credit maximum of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetCreditMaximum
      # @return [Hash] The body content of the SOAP response.
      def self.get_credit_maximum
        response = invoke('Debtor_GetCreditMaximum') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the VatNumber of a debtor. (SE,UK only)
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetVatNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_vat_number
        response = invoke('Debtor_GetVatNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the VatNumber of a debtor. (SE,UK only)
      # Parameters: debtorHandle: Handle for the debtor. value: The new VatNumber of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetVatNumber
      # @return [Hash] The body content of the SOAP response.
      def self.set_vat_number
        response = invoke('Debtor_SetVatNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the County of a debtor. (UK only)
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetCounty
      # @return [Hash] The body content of the SOAP response.
      def self.get_county
        response = invoke('Debtor_GetCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the County of a debtor. (UK only)
      # Parameters: debtorHandle: Handle for the debtor. value: The new County of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetCounty
      # @return [Hash] The body content of the SOAP response.
      def self.set_county
        response = invoke('Debtor_SetCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the Corporate Identification Number of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetCINumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_ci_number
        response = invoke('Debtor_GetCINumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the Corporate Identification Number of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. value: The new Corporate Identification Number of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetCINumber
      # @return [Hash] The body content of the SOAP response.
      def self.set_ci_number
        response = invoke('Debtor_SetCINumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the term of payment of a debtor. The value may not be omitted.
      # Parameters: debtorHandle: Handle for the debtor. value: Handle for new term of payment of a debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetTermOfPayment
      # @return [Hash] The body content of the SOAP response.
      def self.set_term_of_payment
        response = invoke('Debtor_SetTermOfPayment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the term of payment of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      # @return [String] with the id of the debtor term of payment
      def self.get_term_of_payment(number)
        response = invoke('Debtor_GetTermOfPayment') do |message|
          message.add 'debtorHandle' do |debtor_handle|
            debtor_handle.add 'Number', number
          end
        end

        response.fetch(:debtor_get_term_of_payment_response, :debtor_get_term_of_payment_result, :id)
      end

      # Sets the layout of a debtor. The value may be omitted.
      # Parameters: debtorHandle: Handle for the debtor. valueHandle: Handle for new layout of a debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetLayout
      # @return [Hash] The body content of the SOAP response.
      def self.set_layout
        response = invoke('Debtor_SetLayout') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the layout of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetLayout
      # @return [Hash] The body content of the SOAP response.
      def self.get_layout(handle)
        response = invoke('Debtor_GetLayout') do |message|
          message.add 'debtorHandle' do |debtor_handle|
            debtor_handle.add 'Number', handle
          end
        end

        response.fetch(:debtor_get_layout_response, :debtor_get_layout_result, :id)
      end

      # Gets a handle for the attention of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetAttention
      # @return [Hash] The body content of the SOAP response.
      def self.get_attention
        response = invoke('Debtor_GetAttention') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets attention of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. valueHandle: Handle for new attention of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetAttention
      # @return [Hash] The body content of the SOAP response.
      def self.set_attention
        response = invoke('Debtor_SetAttention') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets 'your reference' of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. valueHandle: Handle for 'your reference' of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetYourReference
      # @return [Hash] The body content of the SOAP response.
      def self.set_your_reference
        response = invoke('Debtor_SetYourReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for 'your reference' of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetYourReference
      # @return [Hash] The body content of the SOAP response.
      def self.get_your_reference
        response = invoke('Debtor_GetYourReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for 'our reference' of a debtor.
      # Parameters: debtorHandle: Handle for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetOurReference
      # @return [Hash] The body content of the SOAP response.
      def self.get_our_reference
        response = invoke('Debtor_GetOurReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets 'our reference' of a debtor.
      # Parameters: debtorHandle: Handle for the debtor. valueHandle: Handle for 'our reference' of the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_SetOurReference
      # @return [Hash] The body content of the SOAP response.
      def self.set_our_reference
        response = invoke('Debtor_SetOurReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the current balance of the debtor.
      # Parameters: debtorHandle: Handle for the Debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetBalance
      # @return [Hash] The body content of the SOAP response.
      def self.get_balance
        response = invoke('Debtor_GetBalance') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns the next available debtor number.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetNextAvailableNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_next_available_number
        response = invoke('Debtor_GetNextAvailableNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new debtor.
      #
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_Create
      # @param number [String] Debtor number
      # @param debtor_group_handle [String] Debtor group handle
      # @param name [String] Name of debtor
      # @param vat_zone [String] "HomeCountry" or "EU" or "Abroad"
      # @return [String] The created debtor's handle
      def self.create(number, debtor_group_handle, name, vat_zone)
        response = invoke('Debtor_Create') do |message|
          message.add 'number', number
          message.add 'debtorGroupHandle' do |number|
            number.add 'Number', debtor_group_handle
          end
          message.add 'name', name
          message.add 'vatZone', vat_zone
        end

        response.fetch(:debtor_create_response, :debtor_create_result, :number)
      end

      # Return handles for all debtors
      #
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetAll
      # @return [Array] List of debtor handles
      def self.get_all
        response = invoke('Debtor_GetAll')
        
        response.find('//dns:Number/text()').to_a.map{|x| x.to_s}
      end

      # Return handles for all debtors from date. fromDate is based on CET. includeCalculatedProperties is reserved for future usage and should be set to false for now.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_GetAllUpdated
      # @return [Hash] The body content of the SOAP response.
      def self.get_all_updated
        response = invoke('Debtor_GetAllUpdated') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handle for debtor with a given number.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_FindByNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_number
        response = invoke('Debtor_FindByNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an array with handles for the debtors corresponding to the given debtor numbers. If a debtort with a given number does not exist or if no number is given then the array contains nothing at that index.
      # Parameters: numbers: The numbers to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_FindByNumberList
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_number_list
        response = invoke('Debtor_FindByNumberList') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for debtors with a given name.
      # Parameters: The name to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_FindByName
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_name
        response = invoke('Debtor_FindByName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for debtors with a given partial name.
      # Parameters: The partial name to search for. Asterisks (*) may be used as wildcards.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Debtor_FindByPartialName
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_partial_name
        response = invoke('Debtor_FindByPartialName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
