module Ruconomic
  module API
    module DebtorContact
      extend Ruconomic::WebService

      # Creates a new debtor contact from a data object.
      # Parameters: data: The data object that specifies the properties of the new debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_CreateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data
        response = invoke('DebtorContact_CreateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates new debtor contacts from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new debtor contacts.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('DebtorContact_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Update debtor contacts from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('DebtorContact_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates a debtor contact from a data object.
      # Parameters: data: The data object.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data
        response = invoke('DebtorContact_UpdateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a debtor contact data object for a given debtor contact.
      # Parameters: entityHandle: A handle for the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('DebtorContact_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns debtor contact data objects for a given set of debtor contact handles.
      # Parameters: entityHandles: An array of the debtor contact handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('DebtorContact_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the debtor of a debtor contact.
      # Parameters: debtorContactHandle: Handle for the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_GetDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor
        response = invoke('DebtorContact_GetDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the name of a debtor contact.
      # Parameters: debtorContactHandle: Handle for the debtor contact. value: The new name of the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_SetName
      # @return [Hash] The body content of the SOAP response.
      def self.set_name
        response = invoke('DebtorContact_SetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the name of a debtor contact.
      # Parameters: debtorContactHandle: Handle for the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_GetName
      # @return [Hash] The body content of the SOAP response.
      def self.get_name
        response = invoke('DebtorContact_GetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of a debtor contact.
      # Parameters: debtorContactHandle: Handle for the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_GetNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_number
        response = invoke('DebtorContact_GetNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the telephone number of a debtor contact.
      # Parameters: debtorContactHandle: Handle for the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_GetTelephoneNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_telephone_number
        response = invoke('DebtorContact_GetTelephoneNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the telephone number of a debtor contact.
      # Parameters: debtorContactHandle: Handle for the debtor contact. value: The new telephone number of the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_SetTelephoneNumber
      # @return [Hash] The body content of the SOAP response.
      def self.set_telephone_number
        response = invoke('DebtorContact_SetTelephoneNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the email of a debtor contact.
      # Parameters: debtorContactHandle: Handle for the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_GetEmail
      # @return [Hash] The body content of the SOAP response.
      def self.get_email
        response = invoke('DebtorContact_GetEmail') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the email of a debtor contact.
      # Parameters: debtorContactHandle: Handle for the debtor contact. value: The new email of the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_SetEmail
      # @return [Hash] The body content of the SOAP response.
      def self.set_email
        response = invoke('DebtorContact_SetEmail') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the comments of a debtor contact.
      # Parameters: debtorContactHandle: Handle for the debtor contact. value: The new comments of the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_SetComments
      # @return [Hash] The body content of the SOAP response.
      def self.set_comments
        response = invoke('DebtorContact_SetComments') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the comments of a debtor contact.
      # Parameters: debtorContactHandle: Handle for the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_GetComments
      # @return [Hash] The body content of the SOAP response.
      def self.get_comments
        response = invoke('DebtorContact_GetComments') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the external ID of a debtor contact.
      # Parameters: debtorContactHandle: Handle for the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_GetExternalId
      # @return [Hash] The body content of the SOAP response.
      def self.get_external_id
        response = invoke('DebtorContact_GetExternalId') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the external ID of a debtor contact.
      # Parameters: debtorContactHandle: Handle for the debtor contact. value: The new external ID of the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_SetExternalId
      # @return [Hash] The body content of the SOAP response.
      def self.set_external_id
        response = invoke('DebtorContact_SetExternalId') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets whether the debtor contact is to receive a copy of orders by email.
      # Parameters: debtorContactHandle: Handle for the debtor contact. value: The new value indicating whether the debtor contact is to receive a copy of orders by email.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_SetIsToReceiveEmailCopyOfOrder
      # @return [Hash] The body content of the SOAP response.
      def self.set_is_to_receive_email_copy_of_order
        response = invoke('DebtorContact_SetIsToReceiveEmailCopyOfOrder') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether the debtor contact is to receive a copy of orders by email.
      # Parameters: debtorContactHandle: Handle for the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_GetIsToReceiveEmailCopyOfOrder
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_to_receive_email_copy_of_order
        response = invoke('DebtorContact_GetIsToReceiveEmailCopyOfOrder') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether the debtor contact is to receive a copy of invoices by email.
      # Parameters: debtorContactHandle: Handle for the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_GetIsToReceiveEmailCopyOfInvoice
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_to_receive_email_copy_of_invoice
        response = invoke('DebtorContact_GetIsToReceiveEmailCopyOfInvoice') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets whether the debtor contact is to receive a copy of invoices by email.
      # Parameters: debtorContactHandle: Handle for the debtor contact. value: The new value indicating whether the debtor contact is to receive a copy of invoices by email.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_SetIsToReceiveEmailCopyOfInvoice
      # @return [Hash] The body content of the SOAP response.
      def self.set_is_to_receive_email_copy_of_invoice
        response = invoke('DebtorContact_SetIsToReceiveEmailCopyOfInvoice') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_Create
      # @return [Hash] The body content of the SOAP response.
      def self.create
        response = invoke('DebtorContact_Create') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all debtor contacts.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('DebtorContact_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for debtor contacts with a given name.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_FindByName
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_name
        response = invoke('DebtorContact_FindByName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for debtor contacts with a external ID.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_FindByExternalId
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_external_id
        response = invoke('DebtorContact_FindByExternalId') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Deletes adebtor contact.
      # Parameters: debtorContactHandle: Handle for the debtor contact.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorContact_Delete
      # @return [Hash] The body content of the SOAP response.
      def self.delete
        response = invoke('DebtorContact_Delete') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
