module Ruconomic
  module API
    module DebtorEntry
      extend Ruconomic::WebService

      # Returns a debtor entry data object for a given debtor entry.
      # Parameters: entityHandle: A handle for the debtor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('DebtorEntry_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns debtor entry data objects for a given set of debtor entry handles.
      # Parameters: entityHandles: An array of the debtor entry handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('DebtorEntry_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of the debtor entry.
      # Parameters: debtorentryHandle: Handle for the debtor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetSerialNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_serial_number
        response = invoke('DebtorEntry_GetSerialNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the entry type of the debtor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetType
      # @return [Hash] The body content of the SOAP response.
      def self.get_type
        response = invoke('DebtorEntry_GetType') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the date of the debtor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_date
        response = invoke('DebtorEntry_GetDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor of the debtor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor
        response = invoke('DebtorEntry_GetDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the account of the debtor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetAccount
      # @return [Hash] The body content of the SOAP response.
      def self.get_account
        response = invoke('DebtorEntry_GetAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the voucher number of the debtor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetVoucherNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_voucher_number
        response = invoke('DebtorEntry_GetVoucherNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the text of the debtor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetText
      # @return [Hash] The body content of the SOAP response.
      def self.get_text
        response = invoke('DebtorEntry_GetText') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the amount of the debtor entry in the default currency.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetAmountDefaultCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_amount_default_currency
        response = invoke('DebtorEntry_GetAmountDefaultCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the currency of the debtor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_currency
        response = invoke('DebtorEntry_GetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the currency amount of the debtor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_amount
        response = invoke('DebtorEntry_GetAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the invoice number of the debtor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetInvoiceNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_invoice_number
        response = invoke('DebtorEntry_GetInvoiceNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the due date of the debtor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetDueDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_due_date
        response = invoke('DebtorEntry_GetDueDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the currency remainder of the debtor entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetRemainder
      # @return [Hash] The body content of the SOAP response.
      def self.get_remainder
        response = invoke('DebtorEntry_GetRemainder') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the remainder of the debtor entry in the default currency.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_GetRemainderDefaultCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_remainder_default_currency
        response = invoke('DebtorEntry_GetRemainderDefaultCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an array of handles for the debtor entries with numbers in the given interval.
      # Parameters: from: The beginning of the interval. to: the end of the interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_FindBySerialNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_serial_number
        response = invoke('DebtorEntry_FindBySerialNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for debtor entries for a given invoice number interval.
      # Parameters: from: The minimum invoice number to search for. to: The maximum invoice number to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_FindByInvoiceNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_invoice_number
        response = invoke('DebtorEntry_FindByInvoiceNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Matches the entries passed to the function. No return value.
      # Parameters: entries: The debtor entries to be matched.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DebtorEntry_MatchEntries
      # @return [Hash] The body content of the SOAP response.
      def self.match_entries
        response = invoke('DebtorEntry_MatchEntries') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
