module Ruconomic
  module API
    module DeliveryLocation
      extend Ruconomic::WebService

      # Gets a handle for the debtor of a delivery location.
      # Parameters: deliveryLocationHandle: Handle for the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_GetDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor
        response = invoke('DeliveryLocation_GetDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of a delivery location.
      # Parameters: deliveryLocationHandle: Handle for the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_GetNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_number
        response = invoke('DeliveryLocation_GetNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the address of a delivery location.
      # Parameters: deliveryLocationHandle: Handle for the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_GetAddress
      # @return [Hash] The body content of the SOAP response.
      def self.get_address
        response = invoke('DeliveryLocation_GetAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the address of a delivery location.
      # Parameters: deliveryLocationHandle: Handle for the delivery location. value: The new address of the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_SetAddress
      # @return [Hash] The body content of the SOAP response.
      def self.set_address
        response = invoke('DeliveryLocation_SetAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the postal code of a delivery location.
      # Parameters: deliveryLocationHandle: Handle for the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_GetPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.get_postal_code
        response = invoke('DeliveryLocation_GetPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the postal code of a delivery location.
      # Parameters: deliveryLocationHandle: Handle for the delivery location. value: The new postal code of the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_SetPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.set_postal_code
        response = invoke('DeliveryLocation_SetPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the city of a delivery location.
      # Parameters: deliveryLocationHandle: Handle for the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_GetCity
      # @return [Hash] The body content of the SOAP response.
      def self.get_city
        response = invoke('DeliveryLocation_GetCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the city of a delivery location.
      # Parameters: deliveryLocationHandle: Handle for the delivery location. value: The new city of the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_SetCity
      # @return [Hash] The body content of the SOAP response.
      def self.set_city
        response = invoke('DeliveryLocation_SetCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the country of a delivery location.
      # Parameters: deliveryLocationHandle: Handle for the delivery location. value: The new country of the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_SetCountry
      # @return [Hash] The body content of the SOAP response.
      def self.set_country
        response = invoke('DeliveryLocation_SetCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the country of a delivery location.
      # Parameters: deliveryLocationHandle: Handle for the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_GetCountry
      # @return [Hash] The body content of the SOAP response.
      def self.get_country
        response = invoke('DeliveryLocation_GetCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the terms of delivery of a delivery location.
      # Parameters: deliveryLocationHandle: Handle for the delivery location. value: The new terms of delivery of the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_SetTermsOfDelivery
      # @return [Hash] The body content of the SOAP response.
      def self.set_terms_of_delivery
        response = invoke('DeliveryLocation_SetTermsOfDelivery') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the terms of delivery of a delivery location.
      # Parameters: deliveryLocationHandle: Handle for the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_GetTermsOfDelivery
      # @return [Hash] The body content of the SOAP response.
      def self.get_terms_of_delivery
        response = invoke('DeliveryLocation_GetTermsOfDelivery') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether a delivery location is accessible.
      # Parameters: deliveryLocationHandle: Handle for the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_GetIsAccessible
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_accessible
        response = invoke('DeliveryLocation_GetIsAccessible') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets whether a delivery location is accessible.
      # Parameters: deliveryLocationHandle: Handle for the delivery location. value: Value that indicates whether the delivery location should be accessible.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_SetIsAccessible
      # @return [Hash] The body content of the SOAP response.
      def self.set_is_accessible
        response = invoke('DeliveryLocation_SetIsAccessible') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the external ID of a delivery location.
      # Parameters: deliveryLocationHandle: Handle for the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_GetExternalId
      # @return [Hash] The body content of the SOAP response.
      def self.get_external_id
        response = invoke('DeliveryLocation_GetExternalId') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the external ID of a delivery location.
      # Parameters: deliveryLocationHandle: Handle for the delivery location. value: The new external ID of the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_SetExternalId
      # @return [Hash] The body content of the SOAP response.
      def self.set_external_id
        response = invoke('DeliveryLocation_SetExternalId') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the County of a delivery location. (UK only)
      # Parameters: deliveryLocationHandle: Handle for the deliveryLocation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_GetCounty
      # @return [Hash] The body content of the SOAP response.
      def self.get_county
        response = invoke('DeliveryLocation_GetCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the County of a delivery location. (UK only)
      # Parameters: deliveryLocationHandle: Handle for the deliveryLocation. value: The new County of the deliveryLocation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_SetCounty
      # @return [Hash] The body content of the SOAP response.
      def self.set_county
        response = invoke('DeliveryLocation_SetCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_Create
      # @return [Hash] The body content of the SOAP response.
      def self.create
        response = invoke('DeliveryLocation_Create') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all delivery locations.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('DeliveryLocation_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all delivery location with a given external ID.
      # Parameters: externalId: The external ID to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_FindByExternalId
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_external_id
        response = invoke('DeliveryLocation_FindByExternalId') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Deletes a delivery location
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_Delete
      # @return [Hash] The body content of the SOAP response.
      def self.delete
        response = invoke('DeliveryLocation_Delete') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new delivery location contact from a data object.
      # Parameters: data: The data object that specifies the properties of the new delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_CreateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data
        response = invoke('DeliveryLocation_CreateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates new delivery locations from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new delivery locations.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('DeliveryLocation_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Update delivery locations from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('DeliveryLocation_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates a delivery location from a data object.
      # Parameters: data: The data object.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data
        response = invoke('DeliveryLocation_UpdateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a delivery location data object for a given delivery location.
      # Parameters: entityHandle: A handle for the delivery location.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('DeliveryLocation_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns delivery location data objects for a given set of delivery location handles.
      # Parameters: entityHandles: An array of the delivery location handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DeliveryLocation_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('DeliveryLocation_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
