module Ruconomic
  module API
    module DocumentArchiveCategory
      extend Ruconomic::WebService

      # Update DocumentArchiveCategories from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DocumentArchiveCategory_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('DocumentArchiveCategory_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates a DocumentArchiveCategory from a data object.
      # Parameters: data: The data object.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DocumentArchiveCategory_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data
        response = invoke('DocumentArchiveCategory_UpdateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a DocumentArchiveCategory data object for a given DocumentArchiveCategory.
      # Parameters: entityHandle: A handle for the DocumentArchiveCategory.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DocumentArchiveCategory_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('DocumentArchiveCategory_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns DocumentArchiveCategory data objects for a given set of DocumentArchiveCategory handles.
      # Parameters: entityHandles: An array of the DocumentArchiveCategory handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DocumentArchiveCategory_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('DocumentArchiveCategory_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new DocumentArchiveCategory.
      # Parameters: number: The number of the new DocumentArchiveCategory. name: The name of the new DocumentArchiveCategory.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DocumentArchiveCategory_Create
      # @return [Hash] The body content of the SOAP response.
      def self.create
        response = invoke('DocumentArchiveCategory_Create') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all DocumentArchiveCategories.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DocumentArchiveCategory_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('DocumentArchiveCategory_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a handle for the scanned document with a given number.
      # Parameters: number: The number to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DocumentArchiveCategory_FindByNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_number
        response = invoke('DocumentArchiveCategory_FindByNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for the document archive categories with a given name.
      # Parameter: name: The name to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DocumentArchiveCategory_FindByName
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_name
        response = invoke('DocumentArchiveCategory_FindByName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets all documents in this category.
      # Parameters: invoiceHandle: Handle for the DocumentArchiveCategory.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DocumentArchiveCategory_GetDocuments
      # @return [Hash] The body content of the SOAP response.
      def self.get_documents
        response = invoke('DocumentArchiveCategory_GetDocuments') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Deletes a category.
      # Parameters: documentArchiveCategoryHandle: Handle for the category.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DocumentArchiveCategory_Delete
      # @return [Hash] The body content of the SOAP response.
      def self.delete
        response = invoke('DocumentArchiveCategory_Delete') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of a DocumentArchiveCategory.
      # Parameters: DocumentArchiveCategoryHandle: Handle for the DocumentArchiveCategory.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DocumentArchiveCategory_GetNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_number
        response = invoke('DocumentArchiveCategory_GetNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the name of a DocumentArchiveCategory.
      # Parameters: DocumentArchiveCategoryHandle: Handle for the DocumentArchiveCategory.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DocumentArchiveCategory_GetName
      # @return [Hash] The body content of the SOAP response.
      def self.get_name
        response = invoke('DocumentArchiveCategory_GetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the name of a DocumentArchiveCategory.
      # Parameters: documentArchiveCategoryHandle: Handle for the DocumentArchiveCategory. value: new name of the DocumentArchiveCategory.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=DocumentArchiveCategory_SetName
      # @return [Hash] The body content of the SOAP response.
      def self.set_name
        response = invoke('DocumentArchiveCategory_SetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
