module Ruconomic
  module API
    module Employee
      extend Ruconomic::WebService

      # Deletes an employee.
      # Parameters: employeeHandle: Handle for the employee.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_Delete
      # @return [Hash] The body content of the SOAP response.
      def self.delete
        response = invoke('Employee_Delete') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the time entries of the employee.
      # Parameters: employeeHandle: Handle for the employee.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetTimeEntries
      # @return [Hash] The body content of the SOAP response.
      def self.get_time_entries
        response = invoke('Employee_GetTimeEntries') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the time entries of the employee within an interval.
      # Parameters: from: First day in interval. to: Last day in interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetTimeEntriesByDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_time_entries_by_date
        response = invoke('Employee_GetTimeEntriesByDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the mileage entries of the employee within an interval.
      # Parameters: from: First day in interval. to: Last day in interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetMileageEntriesByDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_mileage_entries_by_date
        response = invoke('Employee_GetMileageEntriesByDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Get sales price for a given employee on the current date.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetSalesPrice
      # @return [Hash] The body content of the SOAP response.
      def self.get_sales_price
        response = invoke('Employee_GetSalesPrice') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Get costprice for a given employee on the current date.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetCostPrice
      # @return [Hash] The body content of the SOAP response.
      def self.get_cost_price
        response = invoke('Employee_GetCostPrice') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the sales price for the given Employee.&lt;br/&gt;Parameters: employeeHandle: Handle for the employee. date: The sales price from the given date for the employee.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetSalesPriceByDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_sales_price_by_date
        response = invoke('Employee_GetSalesPriceByDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the cost price for the given Employee.&lt;br/&gt;Parameters: employeeHandle: Handle for the employee. date: The cost price from the given date for the employee.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetCostPriceByDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_cost_price_by_date
        response = invoke('Employee_GetCostPriceByDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the cost price before of an employee.
      # Parameters: employeeHandle: Handle for the employee. value: The new cost price before of the employee. The value may be null.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_SetCostPriceBefore
      # @return [Hash] The body content of the SOAP response.
      def self.set_cost_price_before
        response = invoke('Employee_SetCostPriceBefore') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the cost price after of an employee.
      # Parameters: employeeHandle: Handle for the employee. value: The new cost price after of the employee. The value may be null.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_SetCostPriceAfter
      # @return [Hash] The body content of the SOAP response.
      def self.set_cost_price_after
        response = invoke('Employee_SetCostPriceAfter') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the sales price before of an employee.
      # Parameters: employeeHandle: Handle for the employee. value: The new sales price before of the employee. The value may be null.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_SetSalesPriceBefore
      # @return [Hash] The body content of the SOAP response.
      def self.set_sales_price_before
        response = invoke('Employee_SetSalesPriceBefore') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the sales price after of an employee.
      # Parameters: employeeHandle: Handle for the employee. value: The new sales price after of the employee. The value may be null.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_SetSalesPriceAfter
      # @return [Hash] The body content of the SOAP response.
      def self.set_sales_price_after
        response = invoke('Employee_SetSalesPriceAfter') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the cost price before of an employee.
      # Parameters: employeeHandle: Handle for the employee. value: The new cost price before of the employee. The value may be null.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetCostPriceBefore
      # @return [Hash] The body content of the SOAP response.
      def self.get_cost_price_before
        response = invoke('Employee_GetCostPriceBefore') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the cost price after of an employee.
      # Parameters: employeeHandle: Handle for the employee. value: The new cost price after of the employee. The value may be null.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetCostPriceAfter
      # @return [Hash] The body content of the SOAP response.
      def self.get_cost_price_after
        response = invoke('Employee_GetCostPriceAfter') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the sales price before of an employee.
      # Parameters: employeeHandle: Handle for the employee.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetSalesPriceBefore
      # @return [Hash] The body content of the SOAP response.
      def self.get_sales_price_before
        response = invoke('Employee_GetSalesPriceBefore') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the sales price after of an employee.
      # Parameters: employeeHandle: Handle for the employee.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetSalesPriceAfter
      # @return [Hash] The body content of the SOAP response.
      def self.get_sales_price_after
        response = invoke('Employee_GetSalesPriceAfter') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the cutoff date of an employee.
      # Parameters: employeeHandle: Handle for the employee. value: The cutoff date for the employee. The value may be null.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_SetCutoffDate
      # @return [Hash] The body content of the SOAP response.
      def self.set_cutoff_date
        response = invoke('Employee_SetCutoffDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the cutoff date of an employee.
      # Parameters: employeeHandle: Handle for the employee.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetCutoffDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_cutoff_date
        response = invoke('Employee_GetCutoffDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new employee from a data object.
      # Parameters: data: The data object that specifies the properties of the new employee.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_CreateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data
        response = invoke('Employee_CreateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates new employees from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new employees.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('Employee_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Update employees from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('Employee_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates an employee from a data object.
      # Parameters: data: The data object.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data
        response = invoke('Employee_UpdateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an employee data object for a given employee.
      # Parameters: entityHandle: A handle for the employee.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('Employee_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns employee data objects for a given set of employee handles.
      # Parameters: entityHandles: An array of the employee handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('Employee_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Retrieve the type of an employee as the enum EmployeeType.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetType
      # @return [Hash] The body content of the SOAP response.
      def self.get_type
        response = invoke('Employee_GetType') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of an employee.
      # Parameters: employeeHandle: Handle for the employee.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_number
        response = invoke('Employee_GetNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handle for the group of an employee.
      # Parameters: employeeHandle: Handle for the employee.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetGroup
      # @return [Hash] The body content of the SOAP response.
      def self.get_group
        response = invoke('Employee_GetGroup') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets handle for the group of an employee.
      # Parameters: employeeHandle: Handle for the employee. valueHandle: Handle for new group of the employee.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_SetGroup
      # @return [Hash] The body content of the SOAP response.
      def self.set_group
        response = invoke('Employee_SetGroup') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets name of an employee.
      # Parameters: employeeHandle: Handle for the employee.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetName
      # @return [Hash] The body content of the SOAP response.
      def self.get_name
        response = invoke('Employee_GetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets name of an employee.
      # Parameters: employeeHandle: Handle for the employee. value: The new name of the employee. The value may not be null.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_SetName
      # @return [Hash] The body content of the SOAP response.
      def self.set_name
        response = invoke('Employee_SetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates an employee.
      # Parameters: number: The number of the new employee. group: Handle for the group of the new employee. name: The name of the new employee.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_Create
      # @return [Hash] The body content of the SOAP response.
      def self.create
        response = invoke('Employee_Create') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all employees.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('Employee_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # The returns handle for the employee with a given number.&lt;br &gt;Parameters: The number to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_FindByNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_number
        response = invoke('Employee_FindByNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an array with handles for the employees corresponding to the given product numbers. If an employee with a given number does not exist then the array contains nothing at that index.
      # Parameters: numbers: The numbers to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_FindByNumberList
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_number_list
        response = invoke('Employee_FindByNumberList') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for employees with a given name.
      # Parameters: name: The name to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Employee_FindByName
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_name
        response = invoke('Employee_FindByName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
