module Ruconomic
  module API
    module Entry
      extend Ruconomic::WebService

      # Returns an entry data object for a given entry.
      # Parameters: entityHandle: A handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('Entry_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns entry data objects for a given set of entry handles.
      # Parameters: entityHandles: An array of the entry handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('Entry_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns the last used serial number, or 0 if no serial numbers exists.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetLastUsedSerialNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_last_used_serial_number
        response = invoke('Entry_GetLastUsedSerialNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an array of handles for the entries with numbers in the given interval.
      # Parameters: minNumber: The start of the interval. maxNumber: The end of the interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_FindBySerialNumberInterval
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_serial_number_interval
        response = invoke('Entry_FindBySerialNumberInterval') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an array of handles for the entries within the given time interval.
      # Parameters: fromDate: First day in interval. toDate: Last day in interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_FindByDateInterval
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_date_interval
        response = invoke('Entry_FindByDateInterval') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of an entry.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetSerialNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_serial_number
        response = invoke('Entry_GetSerialNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Get handle for account of an entry.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetAccount
      # @return [Hash] The body content of the SOAP response.
      def self.get_account
        response = invoke('Entry_GetAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the amount of an entry.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_amount
        response = invoke('Entry_GetAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the amount (in default currency) of an entry.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetAmountDefaultCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_amount_default_currency
        response = invoke('Entry_GetAmountDefaultCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the unit1 of an entry. The unit1 is only accessible when there is access to the Dimension add-on module.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetUnit1
      # @return [Hash] The body content of the SOAP response.
      def self.get_unit1
        response = invoke('Entry_GetUnit1') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the unit2 of an entry. The unit2 is only accessible when there is access to the Dimension add-on module.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetUnit2
      # @return [Hash] The body content of the SOAP response.
      def self.get_unit2
        response = invoke('Entry_GetUnit2') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the quantity1 of an entry. The quantity1 is only accessible when there is access to the Dimension add-on module.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetQuantity1
      # @return [Hash] The body content of the SOAP response.
      def self.get_quantity1
        response = invoke('Entry_GetQuantity1') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the quantity2 of an entry. The quantity2 is only accessible when there is access to the Dimension add-on module.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetQuantity2
      # @return [Hash] The body content of the SOAP response.
      def self.get_quantity2
        response = invoke('Entry_GetQuantity2') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the currency of the entry.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_currency
        response = invoke('Entry_GetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the date of the entry.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_date
        response = invoke('Entry_GetDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the text of the entry.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetText
      # @return [Hash] The body content of the SOAP response.
      def self.get_text
        response = invoke('Entry_GetText') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the entry type of entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetType
      # @return [Hash] The body content of the SOAP response.
      def self.get_type
        response = invoke('Entry_GetType') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the department of an entry. The department is only accessible when there is access to the Dimension add-on module.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetDepartment
      # @return [Hash] The body content of the SOAP response.
      def self.get_department
        response = invoke('Entry_GetDepartment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the distribution key of an entry. The distribution key is only accessible when there is access to the Dimension add-on module.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetDistributionKey
      # @return [Hash] The body content of the SOAP response.
      def self.get_distribution_key
        response = invoke('Entry_GetDistributionKey') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the VAT account of an entry.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetVatAccount
      # @return [Hash] The body content of the SOAP response.
      def self.get_vat_account
        response = invoke('Entry_GetVatAccount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the voucher number of the entry.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetVoucherNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_voucher_number
        response = invoke('Entry_GetVoucherNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handle for the project of the entry.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetProject
      # @return [Hash] The body content of the SOAP response.
      def self.get_project
        response = invoke('Entry_GetProject') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the scanned document of the entry.
      # Parameters: entryHandle: Handle for the entry.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_GetDocument
      # @return [Hash] The body content of the SOAP response.
      def self.get_document
        response = invoke('Entry_GetDocument') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a copy of all the entries that match the same voucher number and date as the selected entry.
      # Parameters: cashBookEntryHandle: Handle for the cashbook entry that is base for the copy. newVoucherNumber: New voucher number if needed. If left out the voucher number from the entry copied is used. newVoucherDate: New voucher date if needed. If left out the date from the entry copied is used. newText: New text if needed. If left out the text from the entry copied is used. newCashBook: The CashBook to create the new entries on.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_CopyVoucher
      # @return [Hash] The body content of the SOAP response.
      def self.copy_voucher
        response = invoke('Entry_CopyVoucher') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Reverse all the entries that belong to the same voucher and are on the same date as this entry. Reverse creates opposite entries, thus undoing the voucher entries. This is done by multiplying amounts by -1.
      # Parameters: cashBookEntryHandle: Handle for the cashbook entry that is base for the copy. newVoucherNumber: New voucher number if needed. If left out the voucher number from the entry copied is used. newVoucherDate: New voucher date if needed. If left out the date from the entry copied is used. newText: New text if needed. If left out the text from the entry copied is used. newCashBook: The CashBook to create the new entries on.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_ReverseVoucher
      # @return [Hash] The body content of the SOAP response.
      def self.reverse_voucher
        response = invoke('Entry_ReverseVoucher') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Turn all the entries that belong to the same voucher and are on the same date as this entry. Turn creates opposite entries, and then proceeds to create entries that have the opposite sign of the voucher entries. This is done by multiplying amounts by -2.
      # Parameters: cashBookEntryHandle: Handle for the cashbook entry that is base for the copy. newVoucherNumber: New voucher number if needed. If left out the voucher number from the entry copied is used. newVoucherDate: New voucher date if needed. If left out the date from the entry copied is used. newText: New text if needed. If left out the text from the entry copied is used. newCashBook: The CashBook to create the new entries on.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Entry_TurnVoucher
      # @return [Hash] The body content of the SOAP response.
      def self.turn_voucher
        response = invoke('Entry_TurnVoucher') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
