module Ruconomic
  module API
    module Order
      extend Ruconomic::WebService

      # Gets the secondary line of text of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetTextLine2
      # @return [Hash] The body content of the SOAP response.
      def self.get_text_line2
        response = invoke('Order_GetTextLine2') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the secondary line of text of an order.
      # Parameters: orderHandle: Handle for the order. value: The new secondary line of text of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetTextLine2
      # @return [Hash] The body content of the SOAP response.
      def self.set_text_line2
        response = invoke('Order_SetTextLine2') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the other reference of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetOtherReference
      # @return [Hash] The body content of the SOAP response.
      def self.get_other_reference
        response = invoke('Order_GetOtherReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the other reference of an order.
      # Parameters: orderHandle: Handle for the order. value: The new other reference of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetOtherReference
      # @return [Hash] The body content of the SOAP response.
      def self.set_other_reference
        response = invoke('Order_SetOtherReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets thether an order is archived.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetIsArchived
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_archived
        response = invoke('Order_GetIsArchived') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether an order is sent.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetIsSent
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_sent
        response = invoke('Order_GetIsSent') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the total amount for all the lines without VAT of an order (in the currency of the order).
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetNetAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_net_amount
        response = invoke('Order_GetNetAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the total VAT amount for all the lines of an order (in the currency of the order).
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetVatAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_vat_amount
        response = invoke('Order_GetVatAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the total gross amount for all the lines of an order (in the currency of the order).
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetGrossAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_gross_amount
        response = invoke('Order_GetGrossAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the margin of an order (in the currency of the order).
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetMargin
      # @return [Hash] The body content of the SOAP response.
      def self.get_margin
        response = invoke('Order_GetMargin') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the margin of an order as percent.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetMarginAsPercent
      # @return [Hash] The body content of the SOAP response.
      def self.get_margin_as_percent
        response = invoke('Order_GetMarginAsPercent') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the rounding amount for all lines of the order (in the currency of the order).
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetRoundingAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_rounding_amount
        response = invoke('Order_GetRoundingAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the DebtorCounty of an order. (UK only)
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDebtorCounty
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_county
        response = invoke('Order_GetDebtorCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the DebtorCounty of an order. (UK only)
      # Parameters: orderHandle: Handle for the order. value: The new DebtorCounty of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDebtorCounty
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_county
        response = invoke('Order_SetDebtorCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the DeliveryCounty of an order. (UK only)
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDeliveryCounty
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_county
        response = invoke('Order_GetDeliveryCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the DeliveryCounty of an order. (UK only)
      # Parameters: orderHandle: Handle for the order. value: The new DeliveryCounty of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDeliveryCounty
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_county
        response = invoke('Order_SetDeliveryCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new order from a data object.
      # Parameters: data: The data object that specifies the properties of the new order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_CreateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data
        response = invoke('Order_CreateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates new orders from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new orders.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('Order_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Update orders from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('Order_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates an order from a data object.
      # Parameters: data: The data object.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data
        response = invoke('Order_UpdateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an order data object for a given order.
      # Parameters: entityHandle: A handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('Order_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns order data objects for a given set of order handles.
      # Parameters: entityHandles: An array of the order handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('Order_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new order. The debtor properties of the new order are set to those of the debtor.
      # Parameters: Handle for the debtr of the new order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_Create
      # @return [Hash] The body content of the SOAP response.
      def self.create
        response = invoke('Order_Create') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets an order as a PDF-file.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetPdf
      # @return [Hash] The body content of the SOAP response.
      def self.get_pdf
        response = invoke('Order_GetPdf') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all orders.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('Order_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all current orders.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetAllCurrent
      # @return [Hash] The body content of the SOAP response.
      def self.get_all_current
        response = invoke('Order_GetAllCurrent') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for the orders with a given other reference.
      # Parameters: otherReference: The other reference to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_FindByOtherReference
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_other_reference
        response = invoke('Order_FindByOtherReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a handle for the order with a given number.
      # Parameters: number: The number to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_FindByNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_number
        response = invoke('Order_FindByNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an array with handles for the orders with numbers in the given interval.
      # Parameters: minNumber: The start of the interval. maxNumber: The end of the interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_FindByNumberInterval
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_number_interval
        response = invoke('Order_FindByNumberInterval') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for orders in a given interval of days.
      # Parameters: first: First day in interval. last: Last day in interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_FindByDateInterval
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_date_interval
        response = invoke('Order_FindByDateInterval') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Return handles for all orders from date. FromDate is based on CET.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetAllUpdated
      # @return [Hash] The body content of the SOAP response.
      def self.get_all_updated
        response = invoke('Order_GetAllUpdated') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for lines of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetLines
      # @return [Hash] The body content of the SOAP response.
      def self.get_lines
        response = invoke('Order_GetLines') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Registers an order as sent.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_RegisterAsSent
      # @return [Hash] The body content of the SOAP response.
      def self.register_as_sent
        response = invoke('Order_RegisterAsSent') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Cancels sent status of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_CancelSentStatus
      # @return [Hash] The body content of the SOAP response.
      def self.cancel_sent_status
        response = invoke('Order_CancelSentStatus') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Upgrades an order to a current invoice.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_UpgradeToInvoice
      # @return [Hash] The body content of the SOAP response.
      def self.upgrade_to_invoice
        response = invoke('Order_UpgradeToInvoice') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Deletes an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_Delete
      # @return [Hash] The body content of the SOAP response.
      def self.delete
        response = invoke('Order_Delete') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the debtor of the order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor
        response = invoke('Order_GetDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets a handle for the debtor of the order.
      # Parameters: orderHandle: Handle for the order. valueHandle: Handle for the new debtor of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor
        response = invoke('Order_SetDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_number
        response = invoke('Order_GetNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor number of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDebtorName
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_name
        response = invoke('Order_GetDebtorName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor number of an order.
      # Parameters: orderHandle: Handle for the order. value: The new debtor number of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDebtorName
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_name
        response = invoke('Order_SetDebtorName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor address of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDebtorAddress
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_address
        response = invoke('Order_GetDebtorAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor address of an order.
      # Parameters: orderHandle: Handle for the order. value: The new debtor address of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDebtorAddress
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_address
        response = invoke('Order_SetDebtorAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor postal code of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDebtorPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_postal_code
        response = invoke('Order_GetDebtorPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor postal code of an order.
      # Parameters: orderHandle: Handle for the order. value: The new debtor postal code of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDebtorPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_postal_code
        response = invoke('Order_SetDebtorPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor city of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDebtorCity
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_city
        response = invoke('Order_GetDebtorCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor city of an order.
      # Parameters: orderHandle: Handle for the order. value: The new debtor city of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDebtorCity
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_city
        response = invoke('Order_SetDebtorCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor country of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDebtorCountry
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_country
        response = invoke('Order_GetDebtorCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor country of an order.
      # Parameters: orderHandle: Handle for the order. value: The new debtor country of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDebtorCountry
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_country
        response = invoke('Order_SetDebtorCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor EAN of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDebtorEan
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_ean
        response = invoke('Order_GetDebtorEan') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor EAN of an order.
      # Parameters: orderHandle: Handle for the order. value: The new debtor EAN of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDebtorEan
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_ean
        response = invoke('Order_SetDebtorEan') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the project related to the order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetProject
      # @return [Hash] The body content of the SOAP response.
      def self.get_project
        response = invoke('Order_GetProject') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets a handle for the project related to the order.
      # Parameters: orderHandle: Handle for the order. projectHandle: handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetProject
      # @return [Hash] The body content of the SOAP response.
      def self.set_project
        response = invoke('Order_SetProject') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the public entry numer of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetPublicEntryNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_public_entry_number
        response = invoke('Order_GetPublicEntryNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the public entry number of an order.
      # Parameters: orderHandle: Handle for the order. value: The new public entry number of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetPublicEntryNumber
      # @return [Hash] The body content of the SOAP response.
      def self.set_public_entry_number
        response = invoke('Order_SetPublicEntryNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the attention of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetAttention
      # @return [Hash] The body content of the SOAP response.
      def self.get_attention
        response = invoke('Order_GetAttention') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the attention of an order.
      # Parameters: orderHandle: Handle for the order. valueHandle: Handle for new attention of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetAttention
      # @return [Hash] The body content of the SOAP response.
      def self.set_attention
        response = invoke('Order_SetAttention') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the attention of the debtor of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetYourReference
      # @return [Hash] The body content of the SOAP response.
      def self.get_your_reference
        response = invoke('Order_GetYourReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the attention for the debtor of an order.
      # Parameters: orderHandle: Handle for the order. valueHandle: Handle for the new reference for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetYourReference
      # @return [Hash] The body content of the SOAP response.
      def self.set_your_reference
        response = invoke('Order_SetYourReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the primary reference of the creditor of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetOurReference
      # @return [Hash] The body content of the SOAP response.
      def self.get_our_reference
        response = invoke('Order_GetOurReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the primary reference of the creditor of an order.
      # Parameters: orderHandle: Handle for the order. valueHandle: Handle for new primary reference of the creditor of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetOurReference
      # @return [Hash] The body content of the SOAP response.
      def self.set_our_reference
        response = invoke('Order_SetOurReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the secondary reference of the creditor of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetOurReference2
      # @return [Hash] The body content of the SOAP response.
      def self.get_our_reference2
        response = invoke('Order_GetOurReference2') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the secondary reference of the creditor of an order.
      # Parameters: orderHandle: Handle for the order. valueHandle: Handle for new secondary reference of the creditor of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetOurReference2
      # @return [Hash] The body content of the SOAP response.
      def self.set_our_reference2
        response = invoke('Order_SetOurReference2') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the date of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_date
        response = invoke('Order_GetDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the date of an order. The due date is calculated accordingly as specified by the term of payment.
      # Parameters: orderHandle: Handle for the order. value: The new date of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDate
      # @return [Hash] The body content of the SOAP response.
      def self.set_date
        response = invoke('Order_SetDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the term of payment of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetTermOfPayment
      # @return [Hash] The body content of the SOAP response.
      def self.get_term_of_payment
        response = invoke('Order_GetTermOfPayment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the term of payment of an order. The due date is calculated accordingly.
      # Parameters: orderHandle: Handle for the order. valueHandle: Handle for new term of payment of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetTermOfPayment
      # @return [Hash] The body content of the SOAP response.
      def self.set_term_of_payment
        response = invoke('Order_SetTermOfPayment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the due date of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDueDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_due_date
        response = invoke('Order_GetDueDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the due date of an order. It is only allowed to set the due date to an actual date when the type of TermOfPayment is set to DueDate.
      # Parameters: orderHandle: Handle for the order. value: The new due date of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDueDate
      # @return [Hash] The body content of the SOAP response.
      def self.set_due_date
        response = invoke('Order_SetDueDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the currency of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_currency
        response = invoke('Order_GetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the currency of an order. The value may not be null.
      # Parameters: orderHandle: Handle for the order. valueHandle: Handle for new currency of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.set_currency
        response = invoke('Order_SetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the exchange rate of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetExchangeRate
      # @return [Hash] The body content of the SOAP response.
      def self.get_exchange_rate
        response = invoke('Order_GetExchangeRate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the exchange rate of an order. The values on the lines are not updated when setting this property.
      # Parameters: orderHandle: Handle for the order. value: The new exchange of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetExchangeRate
      # @return [Hash] The body content of the SOAP response.
      def self.set_exchange_rate
        response = invoke('Order_SetExchangeRate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether the order has VAT included.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetIsVatIncluded
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_vat_included
        response = invoke('Order_GetIsVatIncluded') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets whether the order has VAT included.
      # Parameters: orderHandle: Handle for the order. value: The new value indicating whether the order should include VAT.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetIsVatIncluded
      # @return [Hash] The body content of the SOAP response.
      def self.set_is_vat_included
        response = invoke('Order_SetIsVatIncluded') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the current VAT zone of the Order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetVatZone
      # @return [Hash] The body content of the SOAP response.
      def self.get_vat_zone
        response = invoke('Order_GetVatZone') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the VAT zone of the Order.
      # Parameters: orderHandle: Handle for the order. valueHandle: Handle to the new VAT zone of the Order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetVatZone
      # @return [Hash] The body content of the SOAP response.
      def self.set_vat_zone
        response = invoke('Order_SetVatZone') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the layout of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetLayout
      # @return [Hash] The body content of the SOAP response.
      def self.get_layout
        response = invoke('Order_GetLayout') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the layout of an order.
      # Parameters: orderHandle: Handle for the order. valueHandle: Handle for new layout of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetLayout
      # @return [Hash] The body content of the SOAP response.
      def self.set_layout
        response = invoke('Order_SetLayout') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the delivery location of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDeliveryLocation
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_location
        response = invoke('Order_GetDeliveryLocation') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the delivery location of an order.
      # Parameters: orderHandle: Handle for the order. valueHandle: Handle for new delivery location of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDeliveryLocation
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_location
        response = invoke('Order_SetDeliveryLocation') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery address of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDeliveryAddress
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_address
        response = invoke('Order_GetDeliveryAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the delivery address of an order.
      # Parameters: orderHandle: Handle for the order. value: The new delivery address of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDeliveryAddress
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_address
        response = invoke('Order_SetDeliveryAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery postal code of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDeliveryPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_postal_code
        response = invoke('Order_GetDeliveryPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the delivery postal code of an order.
      # Parameters: orderHandle: Handle for the order. value: The new delivery postal code of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDeliveryPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_postal_code
        response = invoke('Order_SetDeliveryPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery city of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDeliveryCity
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_city
        response = invoke('Order_GetDeliveryCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the delivery city of an order.
      # Parameters: orderHandle: Handle for the order. value: The new delivery city of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDeliveryCity
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_city
        response = invoke('Order_SetDeliveryCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery country of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDeliveryCountry
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_country
        response = invoke('Order_GetDeliveryCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the delivery country of an order.
      # Parameters: orderHandle: Handle for the order. value: The new delivery country of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDeliveryCountry
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_country
        response = invoke('Order_SetDeliveryCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the terms of delivery of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetTermsOfDelivery
      # @return [Hash] The body content of the SOAP response.
      def self.get_terms_of_delivery
        response = invoke('Order_GetTermsOfDelivery') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the terms of delivery of an order.
      # Parameters: orderHandle: Handle for the order. value: The new terms of delivery of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetTermsOfDelivery
      # @return [Hash] The body content of the SOAP response.
      def self.set_terms_of_delivery
        response = invoke('Order_SetTermsOfDelivery') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery date of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetDeliveryDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_date
        response = invoke('Order_GetDeliveryDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the delivery date of an order.
      # Parameters: orderHandle: Handle for the order. value: The new delivery date of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetDeliveryDate
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_date
        response = invoke('Order_SetDeliveryDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the heading of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetHeading
      # @return [Hash] The body content of the SOAP response.
      def self.get_heading
        response = invoke('Order_GetHeading') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the heading of an order.
      # Parameters: orderHandle: Handle for the order. value: The new heading of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetHeading
      # @return [Hash] The body content of the SOAP response.
      def self.set_heading
        response = invoke('Order_SetHeading') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the primary line of text of an order.
      # Parameters: orderHandle: Handle for the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_GetTextLine1
      # @return [Hash] The body content of the SOAP response.
      def self.get_text_line1
        response = invoke('Order_GetTextLine1') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the primary line of text of an order.
      # Parameters: orderHandle: Handle for the order. value: The new primary line of text of the order.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Order_SetTextLine1
      # @return [Hash] The body content of the SOAP response.
      def self.set_text_line1
        response = invoke('Order_SetTextLine1') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
