module Ruconomic
  module API
    module Project
      extend Ruconomic::WebService

      # Creates a new project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_Create
      # @return [Hash] The body content of the SOAP response.
      def self.create
        response = invoke('Project_Create') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Return handles for all projects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('Project_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Return handles for all projects from date. fromDate is based on CET. includeCalculatedProperties is reserved for future usage and should be set to false for now.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetAllUpdated
      # @return [Hash] The body content of the SOAP response.
      def self.get_all_updated
        response = invoke('Project_GetAllUpdated') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a handle for the project with the given number.
      # Parameters: number: The number to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_FindByNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_number
        response = invoke('Project_FindByNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an array with handles for the projects corresponding to the given project numbers. If a project with a given number does not exist or if no number is given then the array contains null at that index.
      # Parameters: numbers: The numbers to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_FindByNumberList
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_number_list
        response = invoke('Project_FindByNumberList') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for the projects with the given name.
      # Parameters: name: The name to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_FindByName
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_name
        response = invoke('Project_FindByName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for the open sub-projects for a given project, or all open sub-projects.
      # Parameters: mainProjectHandle: Handle for main project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetOpenSubProjects
      # @return [Hash] The body content of the SOAP response.
      def self.get_open_sub_projects
        response = invoke('Project_GetOpenSubProjects') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the activities allowed on the project.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetActivities
      # @return [Hash] The body content of the SOAP response.
      def self.get_activities
        response = invoke('Project_GetActivities') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the time entries of the project.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetTimeEntries
      # @return [Hash] The body content of the SOAP response.
      def self.get_time_entries
        response = invoke('Project_GetTimeEntries') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the time entries of the project within an interval.
      # Parameters: from: First day in interval. to: Last day in interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetTimeEntriesByDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_time_entries_by_date
        response = invoke('Project_GetTimeEntriesByDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the mileage entries of the project within an interval.
      # Parameters: from: First day in interval. to: Last day in interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetMileageEntriesByDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_mileage_entries_by_date
        response = invoke('Project_GetMileageEntriesByDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the entries of the project.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetEntries
      # @return [Hash] The body content of the SOAP response.
      def self.get_entries
        response = invoke('Project_GetEntries') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for the entries of the project within the given time interval.
      # Parameters: from: First day in interval. to: Last day in interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetEntriesByDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_entries_by_date
        response = invoke('Project_GetEntriesByDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new project from a data object.
      # Parameters: data: The data object that specifies the properties of the new project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_CreateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data
        response = invoke('Project_CreateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates new projects from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new projects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('Project_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Update projects from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('Project_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates a project from a data object.
      # Parameters: data: The data object.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data
        response = invoke('Project_UpdateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a project data object for a given project.
      # Parameters: entityHandle: A handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('Project_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns project data objects for a given set of project handles.
      # Parameters: entityHandles: An array of the project handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('Project_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of a project.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_number
        response = invoke('Project_GetNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the name of a project.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetName
      # @return [Hash] The body content of the SOAP response.
      def self.get_name
        response = invoke('Project_GetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the name of a project.
      # Parameters: projectHandle: Handle for the project. value: The new name of the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_SetName
      # @return [Hash] The body content of the SOAP response.
      def self.set_name
        response = invoke('Project_SetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handle for project group of a project.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetProjectGroup
      # @return [Hash] The body content of the SOAP response.
      def self.get_project_group
        response = invoke('Project_GetProjectGroup') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the project group of a project.
      # Parameters: projectHandle: Handle for the project. valueHandle: Handle for new project group of the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_SetProjectGroup
      # @return [Hash] The body content of the SOAP response.
      def self.set_project_group
        response = invoke('Project_SetProjectGroup') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether a project is a main project.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetIsMainProject
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_main_project
        response = invoke('Project_GetIsMainProject') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets which main project the project is attached to.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetMainProject
      # @return [Hash] The body content of the SOAP response.
      def self.get_main_project
        response = invoke('Project_GetMainProject') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the debtor of a project.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor
        response = invoke('Project_GetDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets a handle for the debtor of a project.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_SetDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor
        response = invoke('Project_SetDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the employee responsible for the project.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetResponsible
      # @return [Hash] The body content of the SOAP response.
      def self.get_responsible
        response = invoke('Project_GetResponsible') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the employee responsible for the project.
      # Parameters: projectHandle: Handle for the project. value: The new employee responsiblelity of the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_SetResponsible
      # @return [Hash] The body content of the SOAP response.
      def self.set_responsible
        response = invoke('Project_SetResponsible') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the description of a project.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetDescription
      # @return [Hash] The body content of the SOAP response.
      def self.get_description
        response = invoke('Project_GetDescription') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the description of a project.
      # Parameters: projectHandle: Handle for the project. value: The new description of the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_SetDescription
      # @return [Hash] The body content of the SOAP response.
      def self.set_description
        response = invoke('Project_SetDescription') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether a project is accessible.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetIsAccessible
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_accessible
        response = invoke('Project_GetIsAccessible') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets whether a project is accessible.
      # Parameters: projectHandle: Handle for the project. value: Value that indicates whether the project should be accessible.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_SetIsAccessible
      # @return [Hash] The body content of the SOAP response.
      def self.set_is_accessible
        response = invoke('Project_SetIsAccessible') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the mileage of the project.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetMileage
      # @return [Hash] The body content of the SOAP response.
      def self.get_mileage
        response = invoke('Project_GetMileage') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the mileage of the project.
      # Parameters: projectHandle: Handle for the project. value: Value that indicates the mileage of the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_SetMileage
      # @return [Hash] The body content of the SOAP response.
      def self.set_mileage
        response = invoke('Project_SetMileage') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether a project is closed.
      # Parameters: projectHandle: Handle for the project.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Project_GetIsClosed
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_closed
        response = invoke('Project_GetIsClosed') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
