module Ruconomic
  module API
    module Quotation
      extend Ruconomic::WebService

      # Gets the delivery address of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDeliveryAddress
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_address
        response = invoke('Quotation_GetDeliveryAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the delivery address of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new delivery address of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDeliveryAddress
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_address
        response = invoke('Quotation_SetDeliveryAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery postal code of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDeliveryPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_postal_code
        response = invoke('Quotation_GetDeliveryPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the delivery postal code of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new delivery postal code of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDeliveryPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_postal_code
        response = invoke('Quotation_SetDeliveryPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery city of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDeliveryCity
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_city
        response = invoke('Quotation_GetDeliveryCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the delivery city of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new delivery city of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDeliveryCity
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_city
        response = invoke('Quotation_SetDeliveryCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery country of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDeliveryCountry
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_country
        response = invoke('Quotation_GetDeliveryCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the delivery country of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new delivery country of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDeliveryCountry
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_country
        response = invoke('Quotation_SetDeliveryCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the terms of delivery of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetTermsOfDelivery
      # @return [Hash] The body content of the SOAP response.
      def self.get_terms_of_delivery
        response = invoke('Quotation_GetTermsOfDelivery') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the terms of delivery of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new terms of delivery of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetTermsOfDelivery
      # @return [Hash] The body content of the SOAP response.
      def self.set_terms_of_delivery
        response = invoke('Quotation_SetTermsOfDelivery') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery date of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDeliveryDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_date
        response = invoke('Quotation_GetDeliveryDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the delivery date of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new delivery date of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDeliveryDate
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_date
        response = invoke('Quotation_SetDeliveryDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the heading of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetHeading
      # @return [Hash] The body content of the SOAP response.
      def self.get_heading
        response = invoke('Quotation_GetHeading') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the heading of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new heading of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetHeading
      # @return [Hash] The body content of the SOAP response.
      def self.set_heading
        response = invoke('Quotation_SetHeading') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the primary line of text of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetTextLine1
      # @return [Hash] The body content of the SOAP response.
      def self.get_text_line1
        response = invoke('Quotation_GetTextLine1') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the primary line of text of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new primary line of text of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetTextLine1
      # @return [Hash] The body content of the SOAP response.
      def self.set_text_line1
        response = invoke('Quotation_SetTextLine1') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the secondary line of text of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetTextLine2
      # @return [Hash] The body content of the SOAP response.
      def self.get_text_line2
        response = invoke('Quotation_GetTextLine2') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the secondary line of text of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new secondary line of text of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetTextLine2
      # @return [Hash] The body content of the SOAP response.
      def self.set_text_line2
        response = invoke('Quotation_SetTextLine2') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the other reference of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetOtherReference
      # @return [Hash] The body content of the SOAP response.
      def self.get_other_reference
        response = invoke('Quotation_GetOtherReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the other reference of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new other reference of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetOtherReference
      # @return [Hash] The body content of the SOAP response.
      def self.set_other_reference
        response = invoke('Quotation_SetOtherReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets thether an quotation is archived.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetIsArchived
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_archived
        response = invoke('Quotation_GetIsArchived') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether an quotation is sent.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetIsSent
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_sent
        response = invoke('Quotation_GetIsSent') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the total amount for all the lines without VAT of an quotation (in the currency of the quotation).
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetNetAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_net_amount
        response = invoke('Quotation_GetNetAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the total VAT amount for all the lines of an quotation (in the currency of the quotation).
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetVatAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_vat_amount
        response = invoke('Quotation_GetVatAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the total gross amount for all the lines of an quotation (in the currency of the quotation).
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetGrossAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_gross_amount
        response = invoke('Quotation_GetGrossAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the margin of an quotation (in the currency of the quotation).
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetMargin
      # @return [Hash] The body content of the SOAP response.
      def self.get_margin
        response = invoke('Quotation_GetMargin') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the margin of an quotation as percent.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetMarginAsPercent
      # @return [Hash] The body content of the SOAP response.
      def self.get_margin_as_percent
        response = invoke('Quotation_GetMarginAsPercent') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the rounding amount for all lines of the quotation (in the currency of the quotation).
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetRoundingAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_rounding_amount
        response = invoke('Quotation_GetRoundingAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the DebtorCounty of an quotation. (UK only)
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDebtorCounty
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_county
        response = invoke('Quotation_GetDebtorCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the DebtorCounty of an quotation. (UK only)
      # Parameters: quotationHandle: Handle for the quotation. value: The new DebtorCounty of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDebtorCounty
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_county
        response = invoke('Quotation_SetDebtorCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the DeliveryCounty of an quotation. (UK only)
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDeliveryCounty
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_county
        response = invoke('Quotation_GetDeliveryCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the DeliveryCounty of an quotation. (UK only)
      # Parameters: quotationHandle: Handle for the quotation. value: The new DeliveryCounty of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDeliveryCounty
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_county
        response = invoke('Quotation_SetDeliveryCounty') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new quotation from a data object.
      # Parameters: data: The data object that specifies the properties of the new quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_CreateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data
        response = invoke('Quotation_CreateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates new quotations from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new quotations.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('Quotation_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Update quotations from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('Quotation_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates a quotation from a data object.
      # Parameters: data: The data object.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data
        response = invoke('Quotation_UpdateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a quotation data object for a given quotation.
      # Parameters: entityHandle: A handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('Quotation_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns quotation data objects for a given set of quotation handles.
      # Parameters: entityHandles: An array of the quotation handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('Quotation_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new quotation. The debtor properties of the new quotation are set to those of the debtor.
      # Parameters: Handle for the debtr of the new quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_Create
      # @return [Hash] The body content of the SOAP response.
      def self.create
        response = invoke('Quotation_Create') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a quotation as a PDF-file.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetPdf
      # @return [Hash] The body content of the SOAP response.
      def self.get_pdf
        response = invoke('Quotation_GetPdf') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all quotations.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('Quotation_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all quotations.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetAllCurrent
      # @return [Hash] The body content of the SOAP response.
      def self.get_all_current
        response = invoke('Quotation_GetAllCurrent') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for the quotations with a given other reference.
      # Parameters: otherReference: The other reference to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_FindByOtherReference
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_other_reference
        response = invoke('Quotation_FindByOtherReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a handle for the quotation with a given number.
      # Parameters: number: The number to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_FindByNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_number
        response = invoke('Quotation_FindByNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an array with handles for the quotations with numbers in the given interval.
      # Parameters: minNumber: The start of the interval. maxNumber: The end of the interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_FindByNumberInterval
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_number_interval
        response = invoke('Quotation_FindByNumberInterval') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for quotations in a given interval of days.
      # Parameters: first: First day in interval. last: Last day in interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_FindByDateInterval
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_date_interval
        response = invoke('Quotation_FindByDateInterval') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Return handles for all quotations from date. FromDate is based on CET.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetAllUpdated
      # @return [Hash] The body content of the SOAP response.
      def self.get_all_updated
        response = invoke('Quotation_GetAllUpdated') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for lines of a quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetLines
      # @return [Hash] The body content of the SOAP response.
      def self.get_lines
        response = invoke('Quotation_GetLines') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Registers a quotation as sent.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_RegisterAsSent
      # @return [Hash] The body content of the SOAP response.
      def self.register_as_sent
        response = invoke('Quotation_RegisterAsSent') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Cancels sent status of a quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_CancelSentStatus
      # @return [Hash] The body content of the SOAP response.
      def self.cancel_sent_status
        response = invoke('Quotation_CancelSentStatus') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Upgrades a quotation to an order.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_UpgradeToOrder
      # @return [Hash] The body content of the SOAP response.
      def self.upgrade_to_order
        response = invoke('Quotation_UpgradeToOrder') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Deletes a quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_Delete
      # @return [Hash] The body content of the SOAP response.
      def self.delete
        response = invoke('Quotation_Delete') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the debtor of the quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor
        response = invoke('Quotation_GetDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets a handle for the debtor of the quotation.
      # Parameters: quotationHandle: Handle for the quotation. valueHandle: Handle for the new debtor of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor
        response = invoke('Quotation_SetDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of a quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_number
        response = invoke('Quotation_GetNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor number of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDebtorName
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_name
        response = invoke('Quotation_GetDebtorName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor number of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new debtor number of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDebtorName
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_name
        response = invoke('Quotation_SetDebtorName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor address of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDebtorAddress
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_address
        response = invoke('Quotation_GetDebtorAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor address of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new debtor address of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDebtorAddress
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_address
        response = invoke('Quotation_SetDebtorAddress') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor postal code of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDebtorPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_postal_code
        response = invoke('Quotation_GetDebtorPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor postal code of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new debtor postal code of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDebtorPostalCode
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_postal_code
        response = invoke('Quotation_SetDebtorPostalCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor city of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDebtorCity
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_city
        response = invoke('Quotation_GetDebtorCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor city of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new debtor city of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDebtorCity
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_city
        response = invoke('Quotation_SetDebtorCity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor country of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDebtorCountry
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_country
        response = invoke('Quotation_GetDebtorCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor country of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new debtor country of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDebtorCountry
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_country
        response = invoke('Quotation_SetDebtorCountry') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the debtor EAN of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDebtorEan
      # @return [Hash] The body content of the SOAP response.
      def self.get_debtor_ean
        response = invoke('Quotation_GetDebtorEan') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the debtor EAN of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new debtor EAN of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDebtorEan
      # @return [Hash] The body content of the SOAP response.
      def self.set_debtor_ean
        response = invoke('Quotation_SetDebtorEan') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the public entry numer of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetPublicEntryNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_public_entry_number
        response = invoke('Quotation_GetPublicEntryNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the public entry number of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. value: The new public entry number of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetPublicEntryNumber
      # @return [Hash] The body content of the SOAP response.
      def self.set_public_entry_number
        response = invoke('Quotation_SetPublicEntryNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the attention of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetAttention
      # @return [Hash] The body content of the SOAP response.
      def self.get_attention
        response = invoke('Quotation_GetAttention') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the attention of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. valueHandle: Handle for new attention of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetAttention
      # @return [Hash] The body content of the SOAP response.
      def self.set_attention
        response = invoke('Quotation_SetAttention') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the attention of the debtor of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetYourReference
      # @return [Hash] The body content of the SOAP response.
      def self.get_your_reference
        response = invoke('Quotation_GetYourReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the attention for the debtor of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. valueHandle: Handle for the new reference for the debtor.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetYourReference
      # @return [Hash] The body content of the SOAP response.
      def self.set_your_reference
        response = invoke('Quotation_SetYourReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the primary reference of the creditor of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetOurReference
      # @return [Hash] The body content of the SOAP response.
      def self.get_our_reference
        response = invoke('Quotation_GetOurReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the primary reference of the creditor of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. valueHandle: Handle for new primary reference of the creditor of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetOurReference
      # @return [Hash] The body content of the SOAP response.
      def self.set_our_reference
        response = invoke('Quotation_SetOurReference') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the secondary reference of the creditor of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetOurReference2
      # @return [Hash] The body content of the SOAP response.
      def self.get_our_reference2
        response = invoke('Quotation_GetOurReference2') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the secondary reference of the creditor of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. valueHandle: Handle for new secondary reference of the creditor of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetOurReference2
      # @return [Hash] The body content of the SOAP response.
      def self.set_our_reference2
        response = invoke('Quotation_SetOurReference2') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the date of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_date
        response = invoke('Quotation_GetDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the date of an quotation. The due date is calculated accordingly as specified by the term of payment.
      # Parameters: quotationHandle: Handle for the quotation. value: The new date of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDate
      # @return [Hash] The body content of the SOAP response.
      def self.set_date
        response = invoke('Quotation_SetDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the term of payment of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetTermOfPayment
      # @return [Hash] The body content of the SOAP response.
      def self.get_term_of_payment
        response = invoke('Quotation_GetTermOfPayment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the term of payment of an quotation. The due date is calculated accordingly.
      # Parameters: quotationHandle: Handle for the quotation. valueHandle: Handle for new term of payment of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetTermOfPayment
      # @return [Hash] The body content of the SOAP response.
      def self.set_term_of_payment
        response = invoke('Quotation_SetTermOfPayment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the due date of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDueDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_due_date
        response = invoke('Quotation_GetDueDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the due date of an quotation. It is only allowed to set the due date to an actual date when the type of TermOfPayment is set to DueDate.
      # Parameters: quotationHandle: Handle for the quotation. value: The new due date of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDueDate
      # @return [Hash] The body content of the SOAP response.
      def self.set_due_date
        response = invoke('Quotation_SetDueDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the currency of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.get_currency
        response = invoke('Quotation_GetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the currency of an quotation. The value may not be null.
      # Parameters: quotationHandle: Handle for the quotation. valueHandle: Handle for new currency of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetCurrency
      # @return [Hash] The body content of the SOAP response.
      def self.set_currency
        response = invoke('Quotation_SetCurrency') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the exchange rate of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetExchangeRate
      # @return [Hash] The body content of the SOAP response.
      def self.get_exchange_rate
        response = invoke('Quotation_GetExchangeRate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the exchange rate of an quotation. The values on the lines are not updated when setting this property.
      # Parameters: quotationHandle: Handle for the quotation. value: The new exchange of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetExchangeRate
      # @return [Hash] The body content of the SOAP response.
      def self.set_exchange_rate
        response = invoke('Quotation_SetExchangeRate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether the quotation has VAT included.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetIsVatIncluded
      # @return [Hash] The body content of the SOAP response.
      def self.get_is_vat_included
        response = invoke('Quotation_GetIsVatIncluded') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets whether the quotation has VAT included.
      # Parameters: quotationHandle: Handle for the quotation. value: The new value indicating whether the quotation should include VAT.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetIsVatIncluded
      # @return [Hash] The body content of the SOAP response.
      def self.set_is_vat_included
        response = invoke('Quotation_SetIsVatIncluded') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the current VAT zone of the quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetVatZone
      # @return [Hash] The body content of the SOAP response.
      def self.get_vat_zone
        response = invoke('Quotation_GetVatZone') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the current VAT zone of the quotation.
      # Parameters: quotationHandle: Handle for the quotation. valueHandle: The new value handle to an ExtendVatZone.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetVatZone
      # @return [Hash] The body content of the SOAP response.
      def self.set_vat_zone
        response = invoke('Quotation_SetVatZone') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the layout of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetLayout
      # @return [Hash] The body content of the SOAP response.
      def self.get_layout
        response = invoke('Quotation_GetLayout') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the layout of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. valueHandle: Handle for new layout of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetLayout
      # @return [Hash] The body content of the SOAP response.
      def self.set_layout
        response = invoke('Quotation_SetLayout') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the delivery location of an quotation.
      # Parameters: quotationHandle: Handle for the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_GetDeliveryLocation
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_location
        response = invoke('Quotation_GetDeliveryLocation') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the delivery location of an quotation.
      # Parameters: quotationHandle: Handle for the quotation. valueHandle: Handle for new delivery location of the quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Quotation_SetDeliveryLocation
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_location
        response = invoke('Quotation_SetDeliveryLocation') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
