module Ruconomic
  module API
    module QuotationLine
      extend Ruconomic::WebService

      # Creates a new quotation line from a data object.
      # Parameters: data: The data object that specifies the properties of the new quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_CreateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data
        response = invoke('QuotationLine_CreateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates new quotation lines from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new quotation lines.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('QuotationLine_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Update quotation lines from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('QuotationLine_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates an quotation line from a data object.
      # Parameters: data: The data object.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data
        response = invoke('QuotationLine_UpdateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an quotation line data object for a given quotation line.
      # Parameters: entityHandle: A handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('QuotationLine_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns quotation line data objects for a given set of quotation line handles.
      # Parameters: entityHandles: An array of the quotation line handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('QuotationLine_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of an quotation line.
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_number
        response = invoke('QuotationLine_GetNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the quotation of an quotation line.
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetQuotation
      # @return [Hash] The body content of the SOAP response.
      def self.get_quotation
        response = invoke('QuotationLine_GetQuotation') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the description of an quotation line.
      # Parameters: quotationLineHandle: Handle for the quotation line. value: The new description of the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_SetDescription
      # @return [Hash] The body content of the SOAP response.
      def self.set_description
        response = invoke('QuotationLine_SetDescription') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the description of an quotation line.
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetDescription
      # @return [Hash] The body content of the SOAP response.
      def self.get_description
        response = invoke('QuotationLine_GetDescription') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the delivery date of an quotation line.
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetDeliveryDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_delivery_date
        response = invoke('QuotationLine_GetDeliveryDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the delivery date of an quotation line.
      # Parameters: quotationLineHandle: Handle for the quotation line. value: The new delivery date of the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_SetDeliveryDate
      # @return [Hash] The body content of the SOAP response.
      def self.set_delivery_date
        response = invoke('QuotationLine_SetDeliveryDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handle for primary unit of an quotation line.
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetUnit
      # @return [Hash] The body content of the SOAP response.
      def self.get_unit
        response = invoke('QuotationLine_GetUnit') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets primary unit of an quotation line.
      # Parameters: quotationLineHandle: Handle for the quotation line. valueHandle: Handle for new primary unit of the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_SetUnit
      # @return [Hash] The body content of the SOAP response.
      def self.set_unit
        response = invoke('QuotationLine_SetUnit') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handle for product of an quotation line.
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetProduct
      # @return [Hash] The body content of the SOAP response.
      def self.get_product
        response = invoke('QuotationLine_GetProduct') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets product of an quotation line. Setting the product also sets the unit cost price to the cost price of the product. The product must be set before setting the quantity and the unit net price.
      # Parameters: quotationLineHandle: Handle for the quotation line. valueHandle: Handle for new product of the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_SetProduct
      # @return [Hash] The body content of the SOAP response.
      def self.set_product
        response = invoke('QuotationLine_SetProduct') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets primary quantity of an quotation line. The product of the quotation line must be set before setting this property.
      # Parameters: quotationLineHandle: Handle for the quotation line. valueHandle: Handle for primary quantity of the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_SetQuantity
      # @return [Hash] The body content of the SOAP response.
      def self.set_quantity
        response = invoke('QuotationLine_SetQuantity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets primary quantity of an quotation line.
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetQuantity
      # @return [Hash] The body content of the SOAP response.
      def self.get_quantity
        response = invoke('QuotationLine_GetQuantity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets price per unit without VAT of an quotation line (in the currency of the quotation). The product of the quotation line must be set before setting this property.
      # Parameters: quotationLineHandle: Handle for the quotation line. value: The new price per unit without VAT of the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_SetUnitNetPrice
      # @return [Hash] The body content of the SOAP response.
      def self.set_unit_net_price
        response = invoke('QuotationLine_SetUnitNetPrice') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets price per unit without VAT of an quotation line (in the currency of the quotation).
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetUnitNetPrice
      # @return [Hash] The body content of the SOAP response.
      def self.get_unit_net_price
        response = invoke('QuotationLine_GetUnitNetPrice') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets discount of an quotation line as percent.
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetDiscountAsPercent
      # @return [Hash] The body content of the SOAP response.
      def self.get_discount_as_percent
        response = invoke('QuotationLine_GetDiscountAsPercent') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets discount of an quotation line as percent.
      # Parameters: quotationLineHandle: Handle for the quotation line. value: The new discount as percent of the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_SetDiscountAsPercent
      # @return [Hash] The body content of the SOAP response.
      def self.set_discount_as_percent
        response = invoke('QuotationLine_SetDiscountAsPercent') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the cost price per unit witout VAT of an quotation line (in the default currency).
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetUnitCostPrice
      # @return [Hash] The body content of the SOAP response.
      def self.get_unit_cost_price
        response = invoke('QuotationLine_GetUnitCostPrice') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the total amount without VAT of an quotation line (in the currency of the quotation).
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetTotalNetAmount
      # @return [Hash] The body content of the SOAP response.
      def self.get_total_net_amount
        response = invoke('QuotationLine_GetTotalNetAmount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the margin of an quotation line (in the currency of the quotation).
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetTotalMargin
      # @return [Hash] The body content of the SOAP response.
      def self.get_total_margin
        response = invoke('QuotationLine_GetTotalMargin') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the margin as percent of an quotation line.
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetMarginAsPercent
      # @return [Hash] The body content of the SOAP response.
      def self.get_margin_as_percent
        response = invoke('QuotationLine_GetMarginAsPercent') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the department of an quotation line. The department is only accessible when there is access to the Dimension add-on module.
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetDepartment
      # @return [Hash] The body content of the SOAP response.
      def self.get_department
        response = invoke('QuotationLine_GetDepartment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the department of an quotation line. The department is only accessible when there is access to the Dimension add-on module. The department cannot be set when the distribution key is set.
      # Parameters: quotationLineHandle: Handle for the quotation line. value: Handle for the new department of the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_SetDepartment
      # @return [Hash] The body content of the SOAP response.
      def self.set_department
        response = invoke('QuotationLine_SetDepartment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the distribution key of an quotation line. The distribution key is only accessible when there is access to the Dimension add-on module.
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetDistributionKey
      # @return [Hash] The body content of the SOAP response.
      def self.get_distribution_key
        response = invoke('QuotationLine_GetDistributionKey') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the distribution key of an quotation line. The distribution key is only accessible when there is access to the Dimension add-on module. The distribution key cannot be set when the department is set.
      # Parameters: quotationLineHandle: Handle for the quotation line. value: Handle for the new distribution key of the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_SetDistributionKey
      # @return [Hash] The body content of the SOAP response.
      def self.set_distribution_key
        response = invoke('QuotationLine_SetDistributionKey') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new quotation line.
      # Parameters: quotationHandle: Handle for a quotation.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_Create
      # @return [Hash] The body content of the SOAP response.
      def self.create
        response = invoke('QuotationLine_Create') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all quotation lines.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('QuotationLine_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for quotation lines that uses a given product.
      # Parameters: product: The product to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_FindByProduct
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_product
        response = invoke('QuotationLine_FindByProduct') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for quotation lines that uses a given set of products.
      # Parameters: products: The products to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_FindByProductList
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_product_list
        response = invoke('QuotationLine_FindByProductList') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Deletes an quotation line.
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_Delete
      # @return [Hash] The body content of the SOAP response.
      def self.delete
        response = invoke('QuotationLine_Delete') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the inventory location of a quotation line. The inventory location is only accessible when there is access to the Stock add-on module.
      # Parameters: quotationLineHandle: Handle for the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_GetInventoryLocation
      # @return [Hash] The body content of the SOAP response.
      def self.get_inventory_location
        response = invoke('QuotationLine_GetInventoryLocation') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the inventory location of a quotation line. The inventory location is only accessible when there is access to the Stock add-on module.
      # Parameters: quotationLineHandle: Handle for the current invoice line. value: Handle for the new inventory location of the quotation line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=QuotationLine_SetInventoryLocation
      # @return [Hash] The body content of the SOAP response.
      def self.set_inventory_location
        response = invoke('QuotationLine_SetInventoryLocation') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
