module Ruconomic
  module API
    module ReportCode
      extend Ruconomic::WebService

      # Returns a ReportCode data object for a given ReportCode.
      # Parameters: entityHandle: A handle for the ReportCode.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ReportCode_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('ReportCode_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns ReportCode data objects for a given set of ReportCode handles.
      # Parameters: entityHandles: An array of the ReportCode handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ReportCode_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('ReportCode_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the accounts of a report code.
      # Parameters: reportCodeHandle: Handle for the report code.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ReportCode_GetAccounts
      # @return [Hash] The body content of the SOAP response.
      def self.get_accounts
        response = invoke('ReportCode_GetAccounts') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the code of the ReportCode.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ReportCode_GetCode
      # @return [Hash] The body content of the SOAP response.
      def self.get_code
        response = invoke('ReportCode_GetCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the fullcode of the ReportCode.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ReportCode_GetFullCode
      # @return [Hash] The body content of the SOAP response.
      def self.get_full_code
        response = invoke('ReportCode_GetFullCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the parentCode of a ReportCode.
      # Parameters: reportCodeHandle: Handle for the report code.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ReportCode_GetParentCode
      # @return [Hash] The body content of the SOAP response.
      def self.get_parent_code
        response = invoke('ReportCode_GetParentCode') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
