module Ruconomic
  module API
    module ReportCodeSet
      extend Ruconomic::WebService

      # Returns a ReportCodeSet data object for a given ReportCodeSet.
      # Parameters: entityHandle: A handle for the ReportCodeSet.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ReportCodeSet_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('ReportCodeSet_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns ReportCodeSet data objects for a given set of ReportCodeSet handles.
      # Parameters: entityHandles: An array of the ReportCodeSet handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ReportCodeSet_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('ReportCodeSet_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all ReportCodeSets.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ReportCodeSet_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('ReportCodeSet_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for the ReportCodeSets with the given name.
      # Parameters: name: The name to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ReportCodeSet_FindByName
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_name
        response = invoke('ReportCodeSet_FindByName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for ReportCodes in a ReportCodeSet.
      # Parameters: reportCodeSetHandle: Handle for the ReportCodeSet.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ReportCodeSet_GetCodes
      # @return [Hash] The body content of the SOAP response.
      def self.get_codes
        response = invoke('ReportCodeSet_GetCodes') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the name of the ReportCodeSet.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ReportCodeSet_GetName
      # @return [Hash] The body content of the SOAP response.
      def self.get_name
        response = invoke('ReportCodeSet_GetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the codeSet of the ReportCodeSet.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ReportCodeSet_GetCodeSet
      # @return [Hash] The body content of the SOAP response.
      def self.get_code_set
        response = invoke('ReportCodeSet_GetCodeSet') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
