module Ruconomic
  module API
    module ScannedDocument
      extend Ruconomic::WebService

      # Gets the document as a PDF-file.
      # Parameters: invoiceHandle: Handle for the ScannedDocument.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ScannedDocument_GetPdf
      # @return [Hash] The body content of the SOAP response.
      def self.get_pdf
        response = invoke('ScannedDocument_GetPdf') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of a ScannedDocument.
      # Parameters: ScannedDocumentHandle: Handle for the ScannedDocument.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ScannedDocument_GetNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_number
        response = invoke('ScannedDocument_GetNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the status of a ScannedDocument.
      # Parameters: ScannedDocumentHandle: Handle for the ScannedDocument.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ScannedDocument_GetStatus
      # @return [Hash] The body content of the SOAP response.
      def self.get_status
        response = invoke('ScannedDocument_GetStatus') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the category of a ScannedDocument.
      # Parameters: ScannedDocumentHandle: Handle for the ScannedDocument.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ScannedDocument_GetCategory
      # @return [Hash] The body content of the SOAP response.
      def self.get_category
        response = invoke('ScannedDocument_GetCategory') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the note of a ScannedDocument.
      # Parameters: ScannedDocumentHandle: Handle for the ScannedDocument.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ScannedDocument_GetNote
      # @return [Hash] The body content of the SOAP response.
      def self.get_note
        response = invoke('ScannedDocument_GetNote') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the pagecount of a ScannedDocument.
      # Parameters: ScannedDocumentHandle: Handle for the ScannedDocument.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ScannedDocument_GetPageCount
      # @return [Hash] The body content of the SOAP response.
      def self.get_page_count
        response = invoke('ScannedDocument_GetPageCount') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the vouchernumber of a ScannedDocument.
      # Parameters: ScannedDocumentHandle: Handle for the ScannedDocument.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ScannedDocument_GetVoucherNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_voucher_number
        response = invoke('ScannedDocument_GetVoucherNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the fromdate of a ScannedDocument.
      # Parameters: ScannedDocumentHandle: Handle for the ScannedDocument.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ScannedDocument_GetFromDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_from_date
        response = invoke('ScannedDocument_GetFromDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the todate of a ScannedDocument.
      # Parameters: ScannedDocumentHandle: Handle for the ScannedDocument.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ScannedDocument_GetToDate
      # @return [Hash] The body content of the SOAP response.
      def self.get_to_date
        response = invoke('ScannedDocument_GetToDate') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a ScannedDocument data object for a given ScannedDocument.
      # Parameters: entityHandle: A handle for the ScannedDocument.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ScannedDocument_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('ScannedDocument_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns ScannedDocument data objects for a given set of ScannedDocument handles.
      # Parameters: entityHandles: An array of the ScannedDocument handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ScannedDocument_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('ScannedDocument_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all ScannedDocuments.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ScannedDocument_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('ScannedDocument_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a handle for the scanned document with a given voucher number.
      # Parameters: voucherNumber: The number to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ScannedDocument_FindByVoucherNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_voucher_number
        response = invoke('ScannedDocument_FindByVoucherNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns an array with handles for scanned documents with voucher numbers in the given interval.
      # Parameters: minNumber: The start of the interval. maxNumber: The end of the interval.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=ScannedDocument_FindByVoucherNumberInterval
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_voucher_number_interval
        response = invoke('ScannedDocument_FindByVoucherNumberInterval') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
