module Ruconomic
  module API
    module Subscription
      extend Ruconomic::WebService

      # Creates a new subscription from a data object.
      # Parameters: data: The data object that specifies the properties of the new subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_CreateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data
        response = invoke('Subscription_CreateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates new subscriptions from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new subscriptions.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('Subscription_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Update subscriptions from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('Subscription_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates a subscription from a data object.
      # Parameters: data: The data object.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data
        response = invoke('Subscription_UpdateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a subscription data object for a given subscripton.
      # Parameters: entityHandle: A handle for the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('Subscription_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns current subscriptions objects for a given set of subscription handles.
      # Parameters: entityHandles: An array of the subscription handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('Subscription_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the number of the subscription.
      # Parameters: subscriptionHandle: Handle for the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_number
        response = invoke('Subscription_GetNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the name of the subscription.
      # Parameters: subscriptionHandle: Handle for the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetName
      # @return [Hash] The body content of the SOAP response.
      def self.get_name
        response = invoke('Subscription_GetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Set the name of the subscription.
      # Parameters: subscriptionHandle: Handle for the subscription. value: The new name of the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_SetName
      # @return [Hash] The body content of the SOAP response.
      def self.set_name
        response = invoke('Subscription_SetName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the description for the subscription.
      # Parameters: subscriptionHandle: Handle for the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetDescription
      # @return [Hash] The body content of the SOAP response.
      def self.get_description
        response = invoke('Subscription_GetDescription') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the description for the subscription.
      # Parameters: subscriptionHandle: Handle for the subscription. value: The new description of the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_SetDescription
      # @return [Hash] The body content of the SOAP response.
      def self.set_description
        response = invoke('Subscription_SetDescription') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether or not the subscription name should be included as the first product line.
      # Parameters: subscriptionHandle: Handle for the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetIncludeName
      # @return [Hash] The body content of the SOAP response.
      def self.get_include_name
        response = invoke('Subscription_GetIncludeName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets whether or not the subscription name should be included as the first product line.
      # Parameters: subscriptionHandle: Handle for the subscription. value: The new value of the parameter.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_SetIncludeName
      # @return [Hash] The body content of the SOAP response.
      def self.set_include_name
        response = invoke('Subscription_SetIncludeName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the interval of the subscription.
      # Parameters: subscriptionHandle: Handle for the subscription. value: The new interval of the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_SetSubscriptionInterval
      # @return [Hash] The body content of the SOAP response.
      def self.set_subscription_interval
        response = invoke('Subscription_SetSubscriptionInterval') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the interval of the subscription.
      # Parameters: subscriptionHandle: Handle for the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetSubscriptionInterval
      # @return [Hash] The body content of the SOAP response.
      def self.get_subscription_interval
        response = invoke('Subscription_GetSubscriptionInterval') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether or not the subscripton should be created based on the calendar year.
      # Parameters: subscriptionHandle: Handle for the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetCalendarYearBasis
      # @return [Hash] The body content of the SOAP response.
      def self.get_calendar_year_basis
        response = invoke('Subscription_GetCalendarYearBasis') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets whether or not the subscripton should be created based on the calendar year.
      # Parameters: subscriptionHandle: Handle for the subscription. value: The new calendar year state of the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_SetCalendarYearBasis
      # @return [Hash] The body content of the SOAP response.
      def self.set_calendar_year_basis
        response = invoke('Subscription_SetCalendarYearBasis') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets whether or not there should be a Full or Proportional collection for the subscription.
      # Parameters: subscriptionHandle: Handle for the subscription. value: The new collection type of the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_SetCollection
      # @return [Hash] The body content of the SOAP response.
      def self.set_collection
        response = invoke('Subscription_SetCollection') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets whether or not there should be a Full or Proportional collection for the subscription.
      # Parameters: subscriptionHandle: Handle for the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetCollection
      # @return [Hash] The body content of the SOAP response.
      def self.get_collection
        response = invoke('Subscription_GetCollection') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the status whether or not a period should be added after the subscription name.
      # Parameters: subscriptionHandle: Handle for the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetAddPeriod
      # @return [Hash] The body content of the SOAP response.
      def self.get_add_period
        response = invoke('Subscription_GetAddPeriod') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the status whether or not a period should be added after the subscription name.
      # Parameters: subscriptionHandle: Handle for the subscription. value: The status whether or not a period should be added after the subscription name.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_SetAddPeriod
      # @return [Hash] The body content of the SOAP response.
      def self.set_add_period
        response = invoke('Subscription_SetAddPeriod') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets or sets whether more than one subscription is allowed for each debtor.
      # Parameters: subscriptionHandle: Handle for the subscription. value: The new value of the property.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_SetAllowMoreThanOneForEachDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.set_allow_more_than_one_for_each_debtor
        response = invoke('Subscription_SetAllowMoreThanOneForEachDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets or sets whether more than one subscription is allowed for each debtor.
      # Parameters: subscriptionHandle: Handle for the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetAllowMoreThanOneForEachDebtor
      # @return [Hash] The body content of the SOAP response.
      def self.get_allow_more_than_one_for_each_debtor
        response = invoke('Subscription_GetAllowMoreThanOneForEachDebtor') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new subscription.
      # Parameters: subscriptionNumber: subscription number for the subscription. subscriptionName: subscription name for the subscription. description: description for the subscription. includeName: Enables include name for the subscription. subscriptionInterval: subscription interval for the subscription, calendarYearBasis: Enables calendar year for the subscription. collection: Collection for the subscription. addPeriod: enables add period for the subscription. allowMoreThanOneForEachDebtor: enables to allow more than one for each debitor for the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_Create
      # @return [Hash] The body content of the SOAP response.
      def self.create
        response = invoke('Subscription_Create') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handle for subscription with a given number.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_FindByNumber
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_number
        response = invoke('Subscription_FindByNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for the subscriptions with the given name.
      # Parameters: name: The name to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_FindByName
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_name
        response = invoke('Subscription_FindByName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for the lines of the subscription
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetSubscriptionLines
      # @return [Hash] The body content of the SOAP response.
      def self.get_subscription_lines
        response = invoke('Subscription_GetSubscriptionLines') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns the next available subscription number.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetNextAvailableNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_next_available_number
        response = invoke('Subscription_GetNextAvailableNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Deletes a subscription.
      # Parameters: subscriptionHandle: Handle for the subscription.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_Delete
      # @return [Hash] The body content of the SOAP response.
      def self.delete
        response = invoke('Subscription_Delete') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets handles for the subscribers of the subscription
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetSubscribers
      # @return [Hash] The body content of the SOAP response.
      def self.get_subscribers
        response = invoke('Subscription_GetSubscribers') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all subscriptions.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=Subscription_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('Subscription_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
