module Ruconomic
  module API
    module SubscriptionLine
      extend Ruconomic::WebService

      # Gets the number of a subscription line.
      # Parameters: SubscriptionLineHandle: Handle for the subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_GetNumber
      # @return [Hash] The body content of the SOAP response.
      def self.get_number
        response = invoke('SubscriptionLine_GetNumber') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the subscription of a subscription line.
      # Parameters: SubscriptionLineHandle: Handle for the subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_GetSubscription
      # @return [Hash] The body content of the SOAP response.
      def self.get_subscription
        response = invoke('SubscriptionLine_GetSubscription') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the product of a subscription line.
      # Parameters: SubscriptionLineHandle: Handle for the subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_GetProduct
      # @return [Hash] The body content of the SOAP response.
      def self.get_product
        response = invoke('SubscriptionLine_GetProduct') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the product of a subscription line. Setting the product also sets the unit cost price to the cost price of the product. The product must be set before setting the quantity and the unit net price.
      # Parameters: SubscriptionLineHandle: Handle for the subscription line. valueHandle: Handle for the new product of the subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_SetProduct
      # @return [Hash] The body content of the SOAP response.
      def self.set_product
        response = invoke('SubscriptionLine_SetProduct') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the primary quantity of a subscription line.
      # Parameters: subscriptionLineHandle: Handle for the subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_GetQuantity
      # @return [Hash] The body content of the SOAP response.
      def self.get_quantity
        response = invoke('SubscriptionLine_GetQuantity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the primary quantity of a subscription line. The product of the subscription line must be set before setting this property.
      # Parameters: subscriptionLineHandle: Handle for the subscription line. value: The new primary quantity of the subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_SetQuantity
      # @return [Hash] The body content of the SOAP response.
      def self.set_quantity
        response = invoke('SubscriptionLine_SetQuantity') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the department of a subscription line. The department is only accessible when there is access to the Dimension add-on module. The department cannot be set when the distribution key is set.
      # Parameters: subscriptionLineHandle: Handle for the subscription line. value: Handle for the new department of the subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_SetDepartment
      # @return [Hash] The body content of the SOAP response.
      def self.set_department
        response = invoke('SubscriptionLine_SetDepartment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets a handle for the department of a subscription line. The department is only accessible when there is access to the Dimension add-on module.
      # Parameters: subscriptionLineHandle: Handle for the subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_GetDepartment
      # @return [Hash] The body content of the SOAP response.
      def self.get_department
        response = invoke('SubscriptionLine_GetDepartment') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the description of a subscription line.
      # Parameters: subscriptionLineHandle: Handle for the subscription line. value: The new description of the subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_SetProductName
      # @return [Hash] The body content of the SOAP response.
      def self.set_product_name
        response = invoke('SubscriptionLine_SetProductName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the description of a subscription line.
      # Parameters: subscriptionLineHandle: Handle for the subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_GetProductName
      # @return [Hash] The body content of the SOAP response.
      def self.get_product_name
        response = invoke('SubscriptionLine_GetProductName') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Gets the special price of a product.
      # Parameters: subscriptionLineHandle: Handle for the current subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_GetSpecialPrice
      # @return [Hash] The body content of the SOAP response.
      def self.get_special_price
        response = invoke('SubscriptionLine_GetSpecialPrice') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Sets the special price of a product.
      # Parameters: subscriptionLineHandle: Handle for the current subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_SetSpecialPrice
      # @return [Hash] The body content of the SOAP response.
      def self.set_special_price
        response = invoke('SubscriptionLine_SetSpecialPrice') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new subscription line.
      # Parameters: subscriptionHandle: Handle for a subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_Create
      # @return [Hash] The body content of the SOAP response.
      def self.create
        response = invoke('SubscriptionLine_Create') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for subscription lines that use a given products.
      # Parameters: product: The product to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_FindByProduct
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_product
        response = invoke('SubscriptionLine_FindByProduct') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for subscription lines that use a given set of products.
      # Parameters: products: The products to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_FindByProductList
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_product_list
        response = invoke('SubscriptionLine_FindByProductList') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for subscription lines that use a given subscriptions.
      # Parameters: subscription: The subscription to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_FindBySubscription
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_subscription
        response = invoke('SubscriptionLine_FindBySubscription') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for subscription lines that use a given set of subscriptions.
      # Parameters: subscriptions: The subscriptions to search for.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_FindBySubscriptonList
      # @return [Hash] The body content of the SOAP response.
      def self.find_by_subscripton_list
        response = invoke('SubscriptionLine_FindBySubscriptonList') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns handles for all current subsciption lines.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_GetAll
      # @return [Hash] The body content of the SOAP response.
      def self.get_all
        response = invoke('SubscriptionLine_GetAll') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Deletes a subscription line.
      # Parameters: SubscriptionLineHandle: Handle for the subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_Delete
      # @return [Hash] The body content of the SOAP response.
      def self.delete
        response = invoke('SubscriptionLine_Delete') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates a new subscription line from a data object.
      # Parameters: data: The data object that specifies the properties of the new subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_CreateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data
        response = invoke('SubscriptionLine_CreateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Creates new subscription lines from data objects.
      # Parameters: dataArray: The array of data objects that specifies the properties of the new subscription lines.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_CreateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.create_from_data_array
        response = invoke('SubscriptionLine_CreateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Update subscription lines from data objects.
      # Parameters: dataArray: The array of data objects.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_UpdateFromDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data_array
        response = invoke('SubscriptionLine_UpdateFromDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Updates a subscription line from a data object.
      # Parameters: data: The data object.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_UpdateFromData
      # @return [Hash] The body content of the SOAP response.
      def self.update_from_data
        response = invoke('SubscriptionLine_UpdateFromData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns a subscription line data object for a given subscription line.
      # Parameters: entityHandle: A handle for the subscription line.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_GetData
      # @return [Hash] The body content of the SOAP response.
      def self.get_data
        response = invoke('SubscriptionLine_GetData') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

      # Returns subscription line data objects for subscription lines.
      # Parameters: entityHandles: The array of subscription line handles.
      #
      # @note TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
      # @see https://api.e-conomic.com/secure/api1/EconomicWebService.asmx?op=SubscriptionLine_GetDataArray
      # @return [Hash] The body content of the SOAP response.
      def self.get_data_array
        response = invoke('SubscriptionLine_GetDataArray') do |message|
          raise "TODO: This method was autogenerated from the WSDL - see https://github.com/coherify/ruconomic#contributing"
        end
      end

    end
  end
end
